local _, Rotacast = ...
Rotacast.Frames = {}
Rotacast.Functions = {}
Rotacast.Events = {}
Rotacast.Data = {}
function Rotacast.Functions.CreateData()
local PlayerID = UnitGUID("player")
if (RotacastPerDB and RotacastPerDB.PlayerID) then
if (RotacastPerDB.PlayerID ~= PlayerID) then RotacastPerDB = nil; end
end
if (not RotacastPerDB) then RotacastPerDB = {}; end
if (not RotacastPerDB.PlayerID) then RotacastPerDB.PlayerID = PlayerID; end
if (not RotacastPerDB.ScrollBind) then RotacastPerDB.ScrollBind = "Off"; end
if (not RotacastPerDB.ScrollToggle) then RotacastPerDB.ScrollToggle = false; end
if (not RotacastPerDB.LoadShow) then RotacastPerDB.LoadShow = {["Cast"] = true, ["Sequence"] = false, ["Binding"] = false}; end
if (not RotacastPerDB.SequenceOptions) then RotacastPerDB.SequenceOptions = {["AutoCast"] = false, ["Combat"] = false, ["Enter"] = false, ["Leave"] = false, ["Switch"] = false}; end
if (not RotacastPerDB.SequenceOptions.Default) then RotacastPerDB.SequenceOptions.Default = false; end
if (not RotacastPerDB.CastButtonOptions) then RotacastPerDB.CastButtonOptions = {["Shown"] = true, ["Cooldowns"] = true, ["Scale"] = 0}; end
if (not RotacastPerDB.GeneralOptions) then RotacastPerDB.GeneralOptions = {["Locked"] = false, ["AutoCastButton"] = false, ["AutoSequenceBar"] = false}; end
if (not RotacastPerDB.SetPoints) then RotacastPerDB.SetPoints = {["GuideDisplay"] = {}, ["Icon"] = {}, ["CastButton"] = {}, ["Header"] = {}, ["Options"] = {}}; end
if (Rotacast.Data.Expansion == 0) then
if (not RotacastPerDB.SpecData) then RotacastPerDB.SpecData = {["Max"] = 1, ["Current"] = 1, ["Buttons"] = {[1] = {}}, ["HotkeyData"] = {}}; end
end
Rotacast.Data.ReOpen = {false, false, false}
Rotacast.Data.GuideData1 = "|cffff7d0aSlash Commands|r\nType \"/Rotacast\", \"/rotacast\", \"/Rota\", \"/rota\" in chat window for a list of available Slash Commands\n\n|cffff7d0aMinimap Button|r\nLeft click to Show /Hide Cast Button\nRight click to Show /Hide Cast Sequence Bar\nMiddle click to Show /Hide Options\n\n|cffff7d0aOptions Screen\n|cff69ccf0Binding|r\nSet a Hotkey by typing the key or key combination in the box, then click \"Set Hotkey\"\nCancel a Hotkey by clearing the box, then click \"Set Hotkey\"\nTurn Scroll Casting on /off by clicking \"Scroll Cast\"\nUse \"Toggle With Middle Button\" to enable /disable the middle button from turning Scroll Casting on /off\n\n|cff69ccf0Cast Sequence Reset\n|cffffe00aOnly During Combat |r- \"Reset On Target Switch\" will only reset Cast Sequence during combat\n|cffffe00aOn Entering Combat |r- Reset Cast Sequence when entering combat\n|cffffe00aOn Leaving Combat |r- Reset Cast Sequence when leaving combat\n|cffffe00aOn Target Switch |r- Reset Cast Sequence when target is changed\n\n|cff69ccf0Cast Button Appearance\n|cffffe00aShow Background Image |r- Show /Hide the Cast Button background"
Rotacast.Data.GuideData2 = "|cffffe00aShow Cooldowns |r- Show /Hide spell cooldowns on the Cast Button\n|cffffe00aCast Button Size |r- Resize the Cast Button\n\n|cff69ccf0Casting Options\n|cffffe00aUse Cast Sequence 1 As Combat Default |r- Automatically switches to Cast Sequence 1 when combat starts\n|cffffe00aAuto Target |r- Automatically target the next available target if there isn't a current target, or the current target is killed\n\n|cff69ccf0General Options\n|cffffe00aLock Positions |r- Turns dragging of buttons and screens on /off\n|cffffe00aShow Cast Button When Entering Combat |r- Turns automatic showing of \"Cast Button\" when entering combat on /off\n|cffffe00aShow Cast Sequence Bar When Entering Combat |r- Turns automatic showing of \"Cast Sequence Bar\" when entering combat on /off\n\n|cffffe00aRestore Default Positions |r- Restore all windows and Cast Button to their default positions\n|cffffe00aInfo Button |r- Show this help screen\n\n|cffff7d0aCast Sequence Bar|r\nClick the \"Gear\" icon for options to add or delete a Cast Sequence\nUse the Up /Down buttons or press Ctrl+Up /Ctrl+Down to cycle through Cast Sequences\nDrag spells/items/macros around on the Cast Sequence Bar to reorder them\nReplace a spell/item/macro by dragging a new one over it\nLeft click a spell/macro/item on the Cast Sequence Bar to set it as the next to be cast"
Rotacast.Data.GuideData3 = "Right click a spell/item/macro on the Cast Sequence Bar to show its Unique Cast Menu\n\n|cffff7d0aCast Button|r\nDrag spells/items/macros onto the Cast Button to add them to Cast Sequence\nLeft click to cast\nRight click to reset Cast Sequence\nMiddle click to Hide Cast Button\n\n|cffff7d0aUnique Cast Menu|r\n|cffffe00aCast Only Once |r- Only cast once per rotation loop\n|cffffe00aWait For Pet To Attack First |r- Wait for pet to attack before casting\n|cffffe00aSkip On Cooldown |r- Skip over a spell /item if it\'s on cooldown\n|cffffe00aWait On Cooldown |r- Wait until spell /item is off cooldown\n|cffffe00aRequires Target |r- Only cast if there\'s a target\n|cffffe00aWait If Uncastable /Unusable |r- After casting wait if the spell /item was uncastable /unusable (e.g. spell failed)\n|cffffe00aRemove From Sequence |r- Remove from the current cast sequence\n\n|cffff7d0aGeneral Usage|r\n\"Escape\" key can be used to Hide /Close Options Screen, Cast Sequence Bar, Unique Cast Menu\nWhen \"Toggle With Middle Button\" is enabled, click the middle mouse button to turn Scroll Casting on /off\nWhen Scroll Casting is turned on, scroll the mouse wheel to cast the current Cast Sequence"
end
function Rotacast.Functions.SpecData()
Rotacast.Data.CurrentSpec = GetSpecializationInfo(GetSpecialization())
local _, _, ClassID = UnitClass("player")
if (not RotacastPerDB.SpecData) then
RotacastPerDB.SpecData = {}
for X = 1, GetNumSpecializations() do
local ID, _, _, _, _, _ = GetSpecializationInfoForClassID(ClassID, X)
RotacastPerDB.SpecData[ID] = {["Max"] = 1, ["Current"] = 1, ["Buttons"] = {[1] = {}}}
end
end
end
function Rotacast.Functions.UpdateDB()
if (Rotacast.Data.Expansion == 0) then
if (not RotacastPerDB.UpdateVersion) then RotacastPerDB.UpdateVersion = 1; end
else
if (not RotacastPerDB.UpdateVersion) then
if (RotacastPerDB.Update) then RotacastPerDB.Update = nil; end
if (RotacastPerDB.Version) then RotacastPerDB.Version = nil; end
if (RotacastPerDB.Buttons) then RotacastPerDB.Buttons = nil; end
if (RotacastPerDB.CastButtonOptions.Scale) then RotacastPerDB.CastButtonOptions.Scale = 0; end
if (RotacastPerDB.CastButtonOptions.Resize) then RotacastPerDB.CastButtonOptions.Resize = nil; end
for k, v in pairs(RotacastPerDB.SpecData) do
data = {["Max"] = RotacastPerDB.SpecData[k].Max, ["Current"] = RotacastPerDB.SpecData[k].Current, ["Buttons"] = RotacastPerDB.SpecData[k].Buttons, ["HotkeyData"] = {}}
RotacastPerDB.SpecData[k] = data
if (RotacastPerDB.HotKeyName) then RotacastPerDB.SpecData[k].HotkeyData.Name = RotacastPerDB.HotKeyName; end
if (RotacastPerDB.HotkeyBinding) then RotacastPerDB.SpecData[k].HotkeyData.Binding = RotacastPerDB.HotkeyBinding; end
end
if (RotacastPerDB.HotKeyName) then RotacastPerDB.HotKeyName = nil; end
if (RotacastPerDB.HotkeyBinding) then RotacastPerDB.HotkeyBinding = nil; end
data = {["AutoCast"] = false, ["Combat"] = RotacastPerDB.SequenceOptions.Combat, ["Enter"] = RotacastPerDB.SequenceOptions.Enter, ["Leave"] = RotacastPerDB.SequenceOptions.Leave, ["Switch"] = RotacastPerDB.SequenceOptions.Switch}
RotacastPerDB.SequenceOptions = data
RotacastPerDB.UpdateVersion = 1
end
end
if (RotacastPerDB.UpdateVersion == 1) then
RotacastPerDB.UpdateVersion = 2
end
if (RotacastPerDB.UpdateVersion == 2) then
if (Rotacast.Data.Expansion == 0) then
for k, v in pairs(RotacastPerDB.SpecData.Buttons) do
local data1 = {}
for kk, vv in pairs(v) do
table.insert(data1, {["ID"] = vv, ["SingleCast"] = false})
end
RotacastPerDB.SpecData.Buttons[k] = data1
end
else
for k, v in pairs(RotacastPerDB.SpecData) do
for kk, vv in pairs(v.Buttons) do
local data1 = {}
for kkk, vvv in pairs(vv) do
table.insert(data1, {["ID"] = vvv, ["SingleCast"] = false})
end
RotacastPerDB.SpecData[k].Buttons[kk] = data1
end
end
end
RotacastPerDB.UpdateVersion = 3
end
if (RotacastPerDB.UpdateVersion == 3) then
if (RotacastPerDB.SingleCastButtons) then RotacastPerDB.SingleCastButtons = nil; end
if (Rotacast.Data.Expansion == 0) then
for k, v in pairs(RotacastPerDB.SpecData.Buttons) do
for kk, vv in pairs(v) do
RotacastPerDB.SpecData.Buttons[k][kk] = {["ID"] = vv.ID, ["SingleCast"] = vv.SingleCast, ["PetFirst"] = false, ["SkipCooldown"] = false, ["HoldCooldown"] = false, ["RequiresTarget"] = false, ["WaitUncastable"] = false}
end
end
RotacastPerDB.SpecData = {["Max"] = RotacastPerDB.SpecData.Max, ["Current"] = RotacastPerDB.SpecData.Current, ["HotkeyData"] = RotacastPerDB.SpecData.HotkeyData, ["GCD"] = false, ["Buttons"] = RotacastPerDB.SpecData.Buttons}
else
for k, v in pairs(RotacastPerDB.SpecData) do
for kk, vv in pairs(v.Buttons) do
for kkk, vvv in pairs(vv) do
RotacastPerDB.SpecData[k].Buttons[kk][kkk] = {["ID"] = vvv.ID, ["SingleCast"] = vvv.SingleCast, ["PetFirst"] = false, ["SkipCooldown"] = false, ["HoldCooldown"] = false, ["RequiresTarget"] = false, ["WaitUncastable"] = false}
end
end
RotacastPerDB.SpecData[k] = {["Max"] = v.Max, ["Current"] = v.Current, ["HotkeyData"] = v.HotkeyData, ["GCD"] = false, ["Buttons"] = v.Buttons}
end
end
RotacastPerDB.UpdateVersion = 4
end
end
function Rotacast.Functions.Generic(Event, Blocked)
for i = 1, #Blocked do
for k, v in pairs(Blocked[i]) do
if (k == "UnregisterEvent") then
Blocked[i]:UnregisterAllEvents()
break
end
end
Blocked[i]:UnregisterEvent(Event)
end
end
function Rotacast.Functions.IconMessage(Self)
GameTooltip:SetOwner(Self, "ANCHOR_BOTTOMRIGHT")
GameTooltip:SetText("Rotacast")
local Msg1, Msg2, Msg2
if (RotacastPerDB.LoadShow.Cast) then Msg1 = "Hide"; else Msg1 = "Show"; end
if (RotacastPerDB.LoadShow.Sequence) then Msg2 = "Hide"; else Msg2 = "Show"; end
if (RotacastPerDB.LoadShow.Binding) then Msg3 = "Hide"; else Msg3 = "Show"; end
GameTooltip:AddLine("|cffff7d0aLeft Click To |cff69ccf0"..Msg1.."|cffff7d0a Cast Button")
GameTooltip:AddLine("|cffff7d0aRight Click To |cff69ccf0"..Msg2.."|cffff7d0a Cast Sequence Bar")
GameTooltip:AddLine("|cffff7d0aMiddle Click To |cff69ccf0"..Msg3.."|cffff7d0a Options")
GameTooltip:Show()
end
function Rotacast.Functions.UpdateCooldown()
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if (NextCast) then
local CastID = Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("castid")
if (not CastID) then return; end
local Start, Duration, SpellID, IsMacro
if (type(CastID) == "string") then
IsMacro = Rotacast.Functions.FindMacro(CastID)
if (IsMacro) then
SpellID, _, _ =  GetMacroSpell(IsMacro)
if (SpellID and type(SpellID) ~= "table") then Start, Duration, _ = GetSpellCooldown(SpellID); end
else
SpellID = Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("itemid")
if (SpellID) then
if (type(SpellID) == "table") then
if (SpellID.ID) then
Start, Duration, _ = GetItemCooldown(SpellID.ID)
end
else
Start, Duration, _ = GetItemCooldown(SpellID)
end
end
end
else
if (CastID) then Start, Duration, _ = GetSpellCooldown(CastID); end
end
if ((Start and Duration) and (Start ~= 0 and Duration ~= 0)) then 
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, Start, Duration, true)
end
else
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false)
end
end
function Rotacast.Functions.UpdateRangeSpell(SpellName)
local inRange = IsSpellInRange(SpellName, "target")
if (inRange) then
if (inRange == 0) then Rotacast.Frames.CastRange:SetShown(true); elseif (inRange == 1) then Rotacast.Frames.CastRange:SetShown(false); end
else
Rotacast.Frames.CastRange:SetShown(false)
end
end
function Rotacast.Functions.UpdateRangeItem(SpellName)
local inRange = IsItemInRange(SpellName, "target")
if ((inRange == nil) or (inRange == true)) then Rotacast.Frames.CastRange:SetShown(false); elseif (inRange == false) then Rotacast.Frames.CastRange:SetShown(true); end
end
function Rotacast.Functions.UpdateIconsTalent()
local Index = Rotacast.Frames.CastButton:GetAttribute("nextcast")
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Index].ID
if (type(DisplayID) == "table") then Icon = DisplayID.Texture; else _, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID); end
Rotacast.Frames.CastButton.icon:SetTexture(Icon)
for X = 1, #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] do
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID
if (type(DisplayID) == "table") then Icon = DisplayID.Texture; else _, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID); end
Rotacast.Frames.Edit.Button[X].icon:SetTexture(Icon)
end
end
function Rotacast.Functions.FindMacro(Data)
for X = 1, 138 do
if (GetMacroBody(X) == Data) then return X; end
end
end
function Rotacast.Functions.SetSpells()
for X = 1, GetNumSpellTabs() do
local _, _, Min, Max = GetSpellTabInfo(X)
for I = (Min + 1), (Min + Max) do
local Name, _, _, _, _, _, SpellID = GetSpellInfo(I, "spell")
if (Name and SpellID) then Rotacast.Frames.CastButton:SetAttribute("SpellList"..SpellID, Name); end
end
end
end
function Rotacast.Functions.LoadButtons()
local length
if (Rotacast.Data.Expansion ~= 0) then length = #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current]; else length = #RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current]; end
Rotacast.Frames.CastButton:SetAttribute("numbuttons", length)
Rotacast.Functions.SetSpells()
local CastID, ItemID, Icon
for X = 1, length do
local isTable
if (Rotacast.Data.Expansion ~= 0) then
if (type(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID) == "table") then isTable = true; else isTable = false; end
else
if (type(RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID) == "table") then isTable = true; else isTable = false; end
end
if (isTable == true) then
if (Rotacast.Data.Expansion ~= 0) then CastID, ItemID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID.Body, RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID, RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID.Texture; else CastID, ItemID, Icon = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID.Body, RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID, RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID.Texture; end
else
if (Rotacast.Data.Expansion ~= 0) then
CastID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID
_, _, Icon, _, _, _, _ = GetSpellInfo(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID)
else
CastID = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID
_, _, Icon, _, _, _, _ = GetSpellInfo(RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID)
end
if (not Rotacast.Frames.CastButton:GetAttribute("SpellList"..CastID)) then
local Name, _, _, _, _, _, _ = GetSpellInfo(CastID)
Rotacast.Frames.CastButton:SetAttribute("SpellList"..CastID, Name)
end
end
Rotacast.Frames.Edit.Button[X].icon:SetTexture(Icon)
Rotacast.Frames.Edit.Button[X]:Show()
Rotacast.Frames.Edit.Button[X]:SetAttribute("castid", CastID)
Rotacast.Frames.Edit.Button[X]:SetAttribute("itemid", ItemID)
local SingleCast, PetFirst, HoldCooldown, SkipCooldown, RequiresTarget, WaitUncastable
if (Rotacast.Data.Expansion ~= 0) then
SingleCast = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].SingleCast
PetFirst = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].PetFirst
RequiresTarget = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].RequiresTarget
SkipCooldown = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].SkipCooldown
HoldCooldown = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].HoldCooldown
WaitUncastable = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].WaitUncastable
else
SingleCast = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].SingleCast
PetFirst = 	RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].PetFirst
RequiresTarget = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].RequiresTarget
SkipCooldown = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].SkipCooldown
HoldCooldown = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].HoldCooldown
WaitUncastable = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].WaitUncastable
end
Rotacast.Frames.Edit.ButtonAction[X]:SetShown(SingleCast)
Rotacast.Frames.Edit.ButtonAction2[X]:SetShown(PetFirst)
if (SkipCooldown) then
Rotacast.Frames.Edit.ButtonAction3[X].Border:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Green")
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(true)
elseif (HoldCooldown) then
Rotacast.Frames.Edit.ButtonAction3[X].Border:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Red")
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(true)
else
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(false)
end
Rotacast.Frames.Edit.ButtonAction4[X]:SetShown(RequiresTarget)
Rotacast.Frames.Edit.ButtonAction5[X]:SetShown(WaitUncastable)
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecast", SingleCast)
Rotacast.Frames.Edit.Button[X]:SetAttribute("petfirst", PetFirst)
Rotacast.Frames.Edit.Button[X]:SetAttribute("requirestarget", RequiresTarget)
Rotacast.Frames.Edit.Button[X]:SetAttribute("skipcooldown", SkipCooldown)
Rotacast.Frames.Edit.Button[X]:SetAttribute("holdcooldown", HoldCooldown)
Rotacast.Frames.Edit.Button[X]:SetAttribute("waituncastable", WaitUncastable)
end
Rotacast.Frames.CastButton.icon:SetTexture(134400)
if (length ~= 0) then
Rotacast.Frames.CastButton:SetAttribute("nextcast", 1)
Rotacast.Frames.CastButton:SetAttribute("castoption", "set")
else
Rotacast.Frames.Edit.Bar:SetSize(72, 71)
end
Rotacast.Frames.Edit.Bar:SetAttribute("numbuttons", length)
if (Rotacast.Data.Expansion ~= 0) then Rotacast.Frames.Edit.CurrentSequence:SetText(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current.."|cff69ccf0/|cffff7d0a"..RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max); else Rotacast.Frames.Edit.CurrentSequence:SetText(RotacastPerDB.SpecData.Current.."|cff69ccf0/|cffff7d0a"..RotacastPerDB.SpecData.Max); end
end
function Rotacast.Functions.ChangeSpec()
if (Rotacast.Data.CurrentSpec ~= GetSpecializationInfo(GetSpecialization())) then
Rotacast.Data.CurrentSpec = GetSpecializationInfo(GetSpecialization())
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
Rotacast.Frames.Edit.ButtonAction[X]:Hide()
Rotacast.Frames.Edit.ButtonAction2[X]:Hide()
Rotacast.Frames.Edit.ButtonAction3[X]:Hide()
Rotacast.Frames.Edit.ButtonAction4[X]:Hide()
Rotacast.Frames.Edit.ButtonAction5[X]:Hide()
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecast", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecastdone", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("petfirst", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("requirestarget", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("skipcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("holdcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("waituncastable", false)
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end
end
function Rotacast.Functions.ChangeKeyBinding()
for k, v in pairs(RotacastPerDB.SpecData) do
if (RotacastPerDB.SpecData[k].HotkeyData.Binding) then Rotacast.Frames.Binding.KeySave:SetAttribute("clearbinding", RotacastPerDB.SpecData[k].HotkeyData.Binding); end
end
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Binding and RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Name) then
Rotacast.Frames.Binding.KeySave:SetAttribute("resetbindingbind", RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Binding)
Rotacast.Frames.Binding.KeySave:SetAttribute("resetbindingname", RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Name)
end
end
function Rotacast.Functions.CreateSequence()
if (Rotacast.Data.Expansion ~= 0) then
table.insert(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons, {})
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max + 1
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max
else
table.insert(RotacastPerDB.SpecData.Buttons, {})
RotacastPerDB.SpecData.Max = RotacastPerDB.SpecData.Max + 1
RotacastPerDB.SpecData.Current = RotacastPerDB.SpecData.Max
end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
Rotacast.Frames.Edit.ButtonAction[X]:Hide()
Rotacast.Frames.Edit.ButtonAction2[X]:Hide()
Rotacast.Frames.Edit.ButtonAction3[X]:Hide()
Rotacast.Frames.Edit.ButtonAction4[X]:Hide()
Rotacast.Frames.Edit.ButtonAction5[X]:Hide()
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecast", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecastdone", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("petfirst", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("requirestarget", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("skipcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("holdcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("waituncastable", false)
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end
function Rotacast.Functions.DeleteSequence()
if (Rotacast.Data.Expansion ~= 0) then
table.remove(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons, RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current)
local Empty = false
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max - 1
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max <= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max = 1; Empty = true; end
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current - 1
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current <= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max; end
if (Empty) then table.insert(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons, {}); end
else
table.remove(RotacastPerDB.SpecData.Buttons, RotacastPerDB.SpecData.Current)
local Empty = false
RotacastPerDB.SpecData.Max = RotacastPerDB.SpecData.Max - 1
if (RotacastPerDB.SpecData.Max <= 0) then RotacastPerDB.SpecData.Max = 1; Empty = true; end
RotacastPerDB.SpecData.Current = RotacastPerDB.SpecData.Current - 1
if (RotacastPerDB.SpecData.Current <= 0) then RotacastPerDB.SpecData.Current = RotacastPerDB.SpecData.Max; end
if (Empty) then table.insert(RotacastPerDB.SpecData.Buttons, {}); end
end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
Rotacast.Frames.Edit.ButtonAction[X]:Hide()
Rotacast.Frames.Edit.ButtonAction2[X]:Hide()
Rotacast.Frames.Edit.ButtonAction3[X]:Hide()
Rotacast.Frames.Edit.ButtonAction4[X]:Hide()
Rotacast.Frames.Edit.ButtonAction5[X]:Hide()
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecast", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecastdone", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("petfirst", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("requirestarget", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("skipcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("holdcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("waituncastable", false)
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end
function Rotacast.Functions.Tooltip(Self, msg)
Self:SetScript("OnEnter", function()
GameTooltip:SetOwner(Self, "ANCHOR_RIGHT")
GameTooltip:SetText(msg, nil, nil, nil, nil, true)
GameTooltip:Show()
end)
Self:SetScript("OnLeave", function()
GameTooltip_Hide()
end)
end
local function IsOnCooldown(Index)
local CastID = Rotacast.Frames.Edit.Button[Index]:GetAttribute("castid")
if (not CastID) then return false; end
local Start, Duration, SpellID, IsMacro
if (type(CastID) == "string") then
IsMacro = Rotacast.Functions.FindMacro(CastID)
if (IsMacro) then
SpellID, _, _ =  GetMacroSpell(IsMacro)
if (SpellID and type(SpellID) ~= "table") then Start, Duration, _ = GetSpellCooldown(SpellID); end
else
SpellID = Rotacast.Frames.Edit.Button[Index]:GetAttribute("itemid")
if (SpellID) then
if (type(SpellID) == "table") then
if (SpellID.ID) then Start, Duration, _ = GetItemCooldown(SpellID.ID); 	end
else
Start, Duration, _ = GetItemCooldown(SpellID)
end
end
end
else
Start, Duration, _ = GetSpellCooldown(CastID)
end
return ((Start and Duration) and (Start ~= 0 and Duration ~= 0))
end
function Rotacast.Functions.Cooldown_Skip()
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
local NumButtons = Rotacast.Frames.CastButton:GetAttribute("numbuttons")
local NextCastable
local i = NextCast + 1
while i <= NumButtons do
if ((not Rotacast.Frames.Edit.Button[i]:GetAttribute("singlecast")) or ((Rotacast.Frames.Edit.Button[i]:GetAttribute("singlecast")) and (not Rotacast.Frames.Edit.Button[i]:GetAttribute("singlecastdone")))) then
if (IsOnCooldown(i)) then
if (Rotacast.Frames.Edit.Button[i]:GetAttribute("holdcooldown")) then
NextCastable = i
break
elseif (not Rotacast.Frames.Edit.Button[i]:GetAttribute("skipcooldown")) then
NextCastable = i
break
end
else
NextCastable = i
break
end
end
i = i + 1
end
if (not NextCastable) then
i = 1
while i < NextCast do
if ((not Rotacast.Frames.Edit.Button[i]:GetAttribute("singlecast")) or ((Rotacast.Frames.Edit.Button[i]:GetAttribute("singlecast")) and (not Rotacast.Frames.Edit.Button[i]:GetAttribute("singlecastdone")))) then
if (IsOnCooldown(i)) then
if (Rotacast.Frames.Edit.Button[i]:GetAttribute("holdcooldown")) then
NextCastable = i
break
elseif (not Rotacast.Frames.Edit.Button[i]:GetAttribute("skipcooldown")) then
NextCastable = i
break
end
else
NextCastable = i
break
end
end
i = i + 1
end
end
return NextCastable
end
function Rotacast.Functions.Set_SingleCastdone()
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if ((Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("singlecast")) and (not Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("singlecastdone"))) then
CooldownFrame_Set(Rotacast.Frames.GenericSingleFrame[NextCast], 1, 1, true)
end
end
function Rotacast.Functions.Get_UsableItem(NextCast)
local EventMove
local CastID = Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("castid")
if (type(CastID) == "string") then
local ItemID = Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("itemid")
local SpellID
if (type(ItemID) == "table") then
if (ItemID.ID) then SpellID = ItemID.ID; end
else
SpellID = ItemID
end
if (SpellID) then
if (select(1, IsUsableItem(SpellID))) then EventMove = true; else EventMove = false; end
else
EventMove = false
end
else
EventMove = true
end
return EventMove
end
function Rotacast.Functions.DropOptions_Show(Self)
local ButtonID = Self:GetID()
if (ButtonID == Rotacast.Data.DropOptionsID) then
ToggleDropDownMenu(1, nil, Rotacast.Frames.OptionsMenu, Self, -7, 0)
else
Rotacast.Data.DropOptionsID = ButtonID
if (GameTooltip:IsShown()) then GameTooltip:Hide(); end
CloseDropDownMenus()
ToggleDropDownMenu(1, nil, Rotacast.Frames.OptionsMenu, Self, -7, 0)
end
end
function Rotacast.Functions.DropOptions_RemoveSequence()
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame0, 1, 1, true)
end
function Rotacast.Functions.DropOptions_SingleCast()
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame1, 1, 1, true)
end
function Rotacast.Functions.DropOptions_PetFirst()
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame2, 1, 1, true)
end
function Rotacast.Functions.DropOptions_HoldCooldown()
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame6, 1, 1, true)
CloseDropDownMenus()
ToggleDropDownMenu(1, nil, Rotacast.Frames.OptionsMenu, Rotacast.Frames.Edit.Button[Rotacast.Data.DropOptionsID], -7, 0)
end
function Rotacast.Functions.DropOptions_SkipCooldown()
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame7, 1, 1, true)
CloseDropDownMenus()
ToggleDropDownMenu(1, nil, Rotacast.Frames.OptionsMenu, Rotacast.Frames.Edit.Button[Rotacast.Data.DropOptionsID], -7, 0)
end
function Rotacast.Functions.DropOptions_RequiresTarget()
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame9, 1, 1, true)
CloseDropDownMenus()
ToggleDropDownMenu(1, nil, Rotacast.Frames.OptionsMenu, Rotacast.Frames.Edit.Button[Rotacast.Data.DropOptionsID], -7, 0)
end
function Rotacast.Functions.DropOptions_WaitUncastable()
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame12, 1, 1, true)
CloseDropDownMenus()
ToggleDropDownMenu(1, nil, Rotacast.Frames.OptionsMenu, Rotacast.Frames.Edit.Button[Rotacast.Data.DropOptionsID], -7, 0)
end
function Rotacast.Functions.CreateFrames()
Rotacast.Frames.GuideDisplay = CreateFrame("ScrollFrame", "Rotacast.Frames.GuideDisplay", UIParent, "SecureHandlerBaseTemplate, InputScrollFrameTemplate")
tinsert(UISpecialFrames, "Rotacast.Frames.GuideDisplay")
Rotacast.Frames.GuideDisplay:SetFrameStrata("TOOLTIP")
Rotacast.Frames.GuideDisplay:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Marble"}
Rotacast.Frames.GuideDisplay:SetMovable(true)
Rotacast.Frames.GuideDisplay:RegisterForDrag("LeftButton")
Rotacast.Frames.GuideDisplay:SetSize(1050, 500)
Rotacast.Frames.GuideDisplay:SetPoint("Right", -45, 30)
if (RotacastPerDB) then
if (RotacastPerDB.SetPoints.GuideDisplay[1]) then Rotacast.Frames.GuideDisplay:ClearAllPoints(); Rotacast.Frames.GuideDisplay:SetPoint(RotacastPerDB.SetPoints.GuideDisplay[1], RotacastPerDB.SetPoints.GuideDisplay[2], RotacastPerDB.SetPoints.GuideDisplay[3], RotacastPerDB.SetPoints.GuideDisplay[4], RotacastPerDB.SetPoints.GuideDisplay[5]); end
end
Rotacast.Frames.GuideDisplay.CharCount:Hide()
Rotacast.Frames.GuideDisplay.EditBox:SetSize(1050, 1)
Rotacast.Frames.GuideDisplay.EditBox:SetFontObject("ChatFontNormal")
Rotacast.Frames.GuideDisplay.EditBox:SetFont("Fonts\\ARIALN.TTF", 20)
Rotacast.Frames.GuideDisplay.EditBox:EnableMouse(false)
Rotacast.Frames.GuideDisplay.EditBox:EnableKeyboard(false)
Rotacast.Frames.GuideDisplay.EditBox:Disable(true)
Rotacast.Frames.GuideDisplay.EditBox:SetText(Rotacast.Data.GuideData1.."\n"..Rotacast.Data.GuideData2.."\n"..Rotacast.Data.GuideData3)
Rotacast.Frames.GuideDisplay.Close = CreateFrame("Button", nil, Rotacast.Frames.GuideDisplay, "UIPanelCloseButton")
Rotacast.Frames.GuideDisplay.Close:SetSize(40, 40)
Rotacast.Frames.GuideDisplay.Close:SetPoint("TopRight", 10, 37)
Rotacast.Frames.IconContainer = CreateFrame("Frame", "Rotacast.Frames.IconContainer", MinimapCluster, "SecureHandlerBaseTemplate")
Rotacast.Frames.IconContainer:SetSize(32, 32)
Rotacast.Frames.IconContainer:SetPoint("BottomRight")
Rotacast.Frames.IconContainer:SetFrameStrata("High")
Rotacast.Frames.Icon = CreateFrame("Button", "Rotacast.Frames.Icon", Rotacast.Frames.IconContainer, "SecureHandlerClickTemplate")
Rotacast.Frames.Icon:SetClampedToScreen(true)
Rotacast.Frames.Icon:SetMovable(true)
Rotacast.Frames.Icon:EnableMouse(true)
Rotacast.Frames.Icon:SetSize(32, 32)
Rotacast.Frames.Icon:SetPoint("BottomRight")
if (RotacastPerDB) then
if (RotacastPerDB.SetPoints.Icon[1]) then Rotacast.Frames.Icon:ClearAllPoints(); Rotacast.Frames.Icon:SetPoint(RotacastPerDB.SetPoints.Icon[1], RotacastPerDB.SetPoints.Icon[2], RotacastPerDB.SetPoints.Icon[3], RotacastPerDB.SetPoints.Icon[4], RotacastPerDB.SetPoints.Icon[5]); end
end
Rotacast.Frames.Icon:SetFrameStrata("High")
Rotacast.Frames.Icon:SetHighlightTexture(136477)
local Border = Rotacast.Frames.Icon:CreateTexture(nil, "OVERLAY")
Border:SetSize(53, 53)
Border:SetTexture(136430)
Border:SetPoint("TopLeft")
local Background = Rotacast.Frames.Icon:CreateTexture(nil, "BACKGROUND")
Background:SetSize(20, 20)
Background:SetTexture(136467)
Background:SetPoint("TopLeft", 7, -5)
local Icon = Rotacast.Frames.Icon:CreateTexture(nil, "ARTWORK")
if (Rotacast.Data.Expansion ~= 0) then
Icon:SetTexture("Interface\\Addons\\Rotacast\\Images\\Icon")
else
Icon:SetTexture("Interface\\Addons\\RotacastClassic\\Images\\Icon")
end
Icon:SetSize(12,12)
Icon:SetPoint("Center", 0, 0)
Rotacast.Frames.Icon:RegisterForDrag("LeftButton")
Rotacast.Frames.Icon:RegisterForClicks("AnyUp")
Rotacast.Frames.Shield = CreateFrame("Frame", nil, UIParent)
Rotacast.Frames.Shield:SetSize(UIParent:GetWidth(), UIParent:GetHeight())
Rotacast.Frames.Shield:EnableMouse(true)
Rotacast.Frames.Shield:SetPoint("Center")
Rotacast.Frames.Shield:SetFrameStrata("High")
Rotacast.Frames.Shield:Hide()
Rotacast.Frames.GenericContainer = CreateFrame("Frame")
Rotacast.Frames.GenericFrame = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericSlashFrame1 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericSlashFrame2 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericSlashFrame3 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.CastButton = CreateFrame("Button", "Rotacast.Frames.CastButton", UIParent, "ActionButtonTemplate, SecureActionButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerDragTemplate, SecureHandlerAttributeTemplate")
Rotacast.Frames.CastButton:SetClampedToScreen(true)
Rotacast.Frames.CastButton:SetClampRectInsets(-70, 60, 25, -25)
Rotacast.Frames.CastButton:SetMovable(true)
Rotacast.Frames.CastButton:EnableMouse(true)
Rotacast.Frames.CastButton:RegisterForClicks("AnyUp")
Rotacast.Frames.CastButton:RegisterForDrag("LeftButton")
Rotacast.Frames.CastButton:SetID(RotacastPerDB.CastButtonOptions.Scale)
Rotacast.Frames.CastButton:SetSize(35 + RotacastPerDB.CastButtonOptions.Scale * 10, 35 + RotacastPerDB.CastButtonOptions.Scale * 10)
Rotacast.Frames.CastButton:SetPoint("BottomRight", -60, 69)
if (RotacastPerDB) then
if (RotacastPerDB.SetPoints.CastButton[1]) then Rotacast.Frames.CastButton:ClearAllPoints(); Rotacast.Frames.CastButton:SetPoint(RotacastPerDB.SetPoints.CastButton[1], RotacastPerDB.SetPoints.CastButton[2], RotacastPerDB.SetPoints.CastButton[3], RotacastPerDB.SetPoints.CastButton[4], RotacastPerDB.SetPoints.CastButton[5]); end
end
Rotacast.Frames.CastButton:SetFrameStrata("TOOLTIP")
Rotacast.Frames.CastButton:SetFrameLevel(1)
Rotacast.Frames.CastBackground = CreateFrame("Frame", nil, Rotacast.Frames.CastButton, "ActionButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerDragTemplate, SecureHandlerAttributeTemplate")
Rotacast.Frames.CastBackground:SetSize(Rotacast.Frames.CastButton:GetWidth() * 5.71, Rotacast.Frames.CastButton:GetHeight() * 2.85)
Rotacast.Frames.CastBackground:EnableMouse(false)
Rotacast.Frames.CastBackground:SetBackdrop{bgFile = "Interface\\ExtraButton\\AirStrike"}
Rotacast.Frames.CastBackground:SetPoint("Center")
Rotacast.Frames.CastBackground:SetFrameStrata("TOOLTIP")
Rotacast.Frames.CastBackground:SetFrameLevel(1)
Rotacast.Frames.CastBackground:SetShown(RotacastPerDB.CastButtonOptions.Shown)
local Scale, ScaleWidth, ScaleHeight =  Rotacast.Frames.CastButton:GetID()
if (Scale == 0) then ScaleWidth, ScaleHeight = -1, -1; elseif (Scale == 1) then ScaleWidth, ScaleHeight = -2, 1; elseif (Scale == 2) then ScaleWidth, ScaleHeight = -1, 1; elseif (Scale == 3) then ScaleWidth, ScaleHeight = -2, 1; elseif (Scale == 4) then ScaleWidth, ScaleHeight = -3, 1; elseif (Scale == 5) then ScaleWidth, ScaleHeight = -3, 2; elseif (Scale == 6) then ScaleWidth, ScaleHeight = -3, 2; elseif (Scale == 7) then ScaleWidth, ScaleHeight = -3, 2; elseif (Scale == 8) then ScaleWidth, ScaleHeight = -4, 2; elseif (Scale == 9) then ScaleWidth, ScaleHeight = -4, 2; elseif (Scale == 10) then ScaleWidth, ScaleHeight = -5, 2; elseif (Scale == 11) then ScaleWidth, ScaleHeight = -5, 2; elseif (Scale == 12) then ScaleWidth, ScaleHeight = -6, 2; elseif (Scale == 13) then ScaleWidth, ScaleHeight = -7, 2; elseif (Scale == 14) then ScaleWidth, ScaleHeight = -7, 2; elseif (Scale == 15) then ScaleWidth, ScaleHeight = -8, 3; end
Rotacast.Frames.CastBackground:ClearAllPoints()
Rotacast.Frames.CastBackground:SetPoint("Center", Rotacast.Frames.CastButton, "Center", ScaleWidth, ScaleHeight)
Rotacast.Frames.CastButton:SetShown(RotacastPerDB.LoadShow.Cast)
Rotacast.Frames.CastRange = Rotacast.Frames.CastButton:CreateTexture(nil, "ARTWORK")
Rotacast.Frames.CastRange:SetSize(40, 40)
Rotacast.Frames.CastRange:SetTexture("Interface\\BUTTONS\\UI-GroupLoot-Pass-Up")
Rotacast.Frames.CastRange:SetPoint("TopRight")
Rotacast.Frames.CastRange:SetShown(false)
Rotacast.Frames.CastButton.cooldown = CreateFrame("Cooldown", nil, Rotacast.Frames.CastButton, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
if (RotacastPerDB.CastButtonOptions.Cooldowns) then Rotacast.Frames.CastButton.cooldown:SetAlpha(1); else Rotacast.Frames.CastButton.cooldown:SetAlpha(0); end
Rotacast.Frames.GenericSizeFrames = {}
for X = 0, 15 do
Rotacast.Frames.GenericSizeFrames[X] = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericSizeFrames[X]:SetID(X)
Rotacast.Frames.GenericSizeFrames[X]:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericSizeFrames[X]:SetFrameRef("Rotacast.Frames.CastBackground", Rotacast.Frames.CastBackground)
Rotacast.Frames.GenericSizeFrames[X]:SetAttribute("_onshow", [=[
self:Hide()
local value = self:GetID()
local Ref1 = self:GetFrameRef("Rotacast.Frames.CastButton")
local Ref2 = self:GetFrameRef("Rotacast.Frames.CastBackground")
Ref1:SetWidth(35 + value * 10)
Ref1:SetHeight(35 + value * 10)
Ref2:SetWidth(Ref1:GetWidth() * 5.71)
Ref2:SetHeight(Ref1:GetHeight() * 2.85)
local ScaleWidth, ScaleHeight
if (value == 0) then ScaleWidth, ScaleHeight = -1, -1; elseif (value == 1) then ScaleWidth, ScaleHeight = -2, 1; elseif (value == 2) then ScaleWidth, ScaleHeight = -1, 1; elseif (value == 3) then ScaleWidth, ScaleHeight = -2, 1; elseif (value == 4) then ScaleWidth, ScaleHeight = -3, 1; elseif (value == 5) then ScaleWidth, ScaleHeight = -3, 2; elseif (value == 6) then ScaleWidth, ScaleHeight = -3, 2; elseif (value == 7) then ScaleWidth, ScaleHeight = -3, 2; elseif (value == 8) then ScaleWidth, ScaleHeight = -4, 2; elseif (value == 9) then ScaleWidth, ScaleHeight = -4, 2; elseif (value == 10) then ScaleWidth, ScaleHeight = -5, 2; elseif (value == 11) then ScaleWidth, ScaleHeight = -5, 2; elseif (value == 12) then ScaleWidth, ScaleHeight = -6, 2; elseif (value == 13) then ScaleWidth, ScaleHeight = -7, 2; elseif (value == 14) then ScaleWidth, ScaleHeight = -7, 2; elseif (value == 15) then ScaleWidth, ScaleHeight = -8, 3; end
Ref2:ClearAllPoints()
Ref2:SetPoint("CENTER", Ref1, "CENTER", ScaleWidth, ScaleHeight)
]=])
end
Rotacast.Frames.OptionsMenu = CreateFrame("Frame")
Rotacast.Frames.OptionsMenu.displayMode = "MENU"
Rotacast.Frames.OptionsMenu.RotaMenu = true
UIDropDownMenu_Initialize(Rotacast.Frames.OptionsMenu, function(Self, Level)
Level = Level or 1
if (Level == 1) then
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffffe00a"
Info.text = "Cast Only Once"
Info.keepShownOnClick = true
if (Rotacast.Data.Expansion ~= 0) then
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Rotacast.Data.DropOptionsID].SingleCast or false; end
else
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Rotacast.Data.DropOptionsID].SingleCast or false; end
end
Info.isNotRadio = true
Info.func = function() Rotacast.Functions.DropOptions_SingleCast() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffffe00a"
Info.text = "Wait For Pet To Attack First"
Info.keepShownOnClick = true
if (Rotacast.Data.Expansion ~= 0) then
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Rotacast.Data.DropOptionsID].PetFirst or false; end
else
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Rotacast.Data.DropOptionsID].PetFirst or false; end
end
Info.isNotRadio = true
Info.func = function() Rotacast.Functions.DropOptions_PetFirst() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffffe00a"
Info.text = "Skip On Cooldown"
Info.keepShownOnClick = true
if (Rotacast.Data.Expansion ~= 0) then
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Rotacast.Data.DropOptionsID].SkipCooldown or false; end
else
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Rotacast.Data.DropOptionsID].SkipCooldown or false; end
end
Info.func = function() Rotacast.Functions.DropOptions_SkipCooldown() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffffe00a"
Info.text = "Wait On Cooldown"
Info.keepShownOnClick = true
if (Rotacast.Data.Expansion ~= 0) then
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Rotacast.Data.DropOptionsID].HoldCooldown or false; end
else
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Rotacast.Data.DropOptionsID].HoldCooldown or false; end
end
Info.func = function() Rotacast.Functions.DropOptions_HoldCooldown() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffffe00a"
Info.text = "Requires Target"
Info.keepShownOnClick = true
if (Rotacast.Data.Expansion ~= 0) then
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Rotacast.Data.DropOptionsID].RequiresTarget or false; end
else
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Rotacast.Data.DropOptionsID].RequiresTarget or false; end
end
Info.isNotRadio = true
Info.func = function() Rotacast.Functions.DropOptions_RequiresTarget() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffffe00a"
Info.text = "Wait If Uncastable/Unusable"
Info.keepShownOnClick = true
if (Rotacast.Data.Expansion ~= 0) then
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Rotacast.Data.DropOptionsID].WaitUncastable or false; end
else
if (Rotacast.Data.DropOptionsID) then Info.checked = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Rotacast.Data.DropOptionsID].WaitUncastable or false; end
end
Info.isNotRadio = true
if (Rotacast.Data.DropOptionsID) then
Info.disabled = not Rotacast.Functions.Get_UsableItem(Rotacast.Data.DropOptionsID)
end
Info.func = function() Rotacast.Functions.DropOptions_WaitUncastable() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.isTitle = true
Info.notCheckable = true
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.isTitle = true
Info.notCheckable = true
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffffe00a"
Info.text = "Remove From Sequence"
Info.notCheckable = true
Info.func = function() Rotacast.Functions.DropOptions_RemoveSequence() end
UIDropDownMenu_AddButton(Info, Level)
end
end)
Rotacast.Frames.Edit = {}
Rotacast.Frames.Edit.CreateMenu = CreateFrame("Frame")
Rotacast.Frames.Edit.CreateMenu.displayMode = "MENU"
UIDropDownMenu_Initialize(Rotacast.Frames.Edit.CreateMenu, function(Self, Level)
Level = Level or 1
if (Level == 1) then
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffff7d0a"
Info.text = "Add New Sequence"
Info.notCheckable = true
Info.func = function() Rotacast.Functions.CreateSequence() end
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.isTitle = true
Info.notCheckable = true
UIDropDownMenu_AddButton(Info, Level)
local Info = UIDropDownMenu_CreateInfo()
Info.fontObject = "GameFontNormal"
Info.colorCode = "|cffff7d0a"
Info.text = "Delete Current Sequence"
Info.notCheckable = true
Info.func = function() Rotacast.Functions.DeleteSequence() end
UIDropDownMenu_AddButton(Info, Level)
end
end)
Rotacast.Frames.Edit.Header = CreateFrame("Frame", "Rotacast.Frames.Edit.Header", UIParent, "TooltipBorderedFrameTemplate")
Rotacast.Frames.Edit.Header:SetSize(235, 30)
Rotacast.Frames.Edit.Header:SetMovable(true)
Rotacast.Frames.Edit.Header:EnableMouse(true)
Rotacast.Frames.Edit.Header:RegisterForDrag("LeftButton")
Rotacast.Frames.Edit.Header:SetPoint("Top")
if (RotacastPerDB) then
if (RotacastPerDB.SetPoints.Header[1]) then Rotacast.Frames.Edit.Header:ClearAllPoints(); Rotacast.Frames.Edit.Header:SetPoint(RotacastPerDB.SetPoints.Header[1], RotacastPerDB.SetPoints.Header[2], RotacastPerDB.SetPoints.Header[3], RotacastPerDB.SetPoints.Header[4], RotacastPerDB.SetPoints.Header[5]); end
end
Rotacast.Frames.Edit.Header:SetFrameStrata("High")
Rotacast.Frames.Edit.Header:SetShown(RotacastPerDB.LoadShow.Sequence)
Rotacast.Frames.Edit.Title = Rotacast.Frames.Edit.Header:CreateFontString("ARTWORK")
Rotacast.Frames.Edit.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Edit.Title:SetPoint("Left", 33, 0)
Rotacast.Frames.Edit.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.Edit.Title:SetText("Cast Sequence")
Rotacast.Frames.Edit.CurrentSequence = Rotacast.Frames.Edit.Header:CreateFontString("ARTWORK")
Rotacast.Frames.Edit.CurrentSequence:SetFontObject("GameFontNormal")
Rotacast.Frames.Edit.CurrentSequence:SetPoint("Left", Rotacast.Frames.Edit.Title, "Right", 2, 0)
Rotacast.Frames.Edit.CurrentSequence:SetTextColor(1, 0.96, 0.41, 1)
Rotacast.Frames.Edit.Bar = CreateFrame("Frame", "Rotacast.Frames.Edit.Bar", Rotacast.Frames.Edit.Header, "SecureHandlerAttributeTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.Edit.Bar:SetClampedToScreen(true)
Rotacast.Frames.Edit.Bar:EnableMouse(true)
Rotacast.Frames.Edit.Bar:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Marble", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = false,	 insets = {left = 3, right = 3, top = 3, bottom = 3}, tileSize = 32, edgeSize = 16}
Rotacast.Frames.Edit.Bar:SetSize(72, 71)
Rotacast.Frames.Edit.Bar:SetPoint("Top", 0, -27)
Rotacast.Frames.Edit.Bar:SetFrameStrata("High")
Rotacast.Frames.Edit.Bar:SetShown(RotacastPerDB.LoadShow.Sequence)
local Background = Rotacast.Frames.Edit.Bar:CreateTexture(nil, "ARTWORK")
Background:SetSize(25, 30)
Background:SetTexture("Interface\\GossipFrame\\ActiveQuestIcon")
Background:SetPoint("TopLeft", 22, -22)
Rotacast.Frames.Edit.CreateSequence = CreateFrame("Button", nil, Rotacast.Frames.Edit.Header)
Rotacast.Frames.Edit.CreateSequence:SetSize(20, 20)
Rotacast.Frames.Edit.CreateSequence:SetNormalTexture("Interface\\BUTTONS\\UI-OptionsButton")
Rotacast.Frames.Edit.CreateSequence:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
Rotacast.Frames.Edit.CreateSequence:SetPoint("Left", 8, 0)
Rotacast.Frames.Edit.SequenceDown = CreateFrame("Button", "Rotacast.Frames.Edit.SequenceDown", Rotacast.Frames.Edit.Header, "SecureHandlerAttributeTemplate")
Rotacast.Frames.Edit.SequenceDown:SetSize(25, 25)
Rotacast.Frames.Edit.SequenceDown:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Up")
Rotacast.Frames.Edit.SequenceDown:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
Rotacast.Frames.Edit.SequenceDown:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Disabled")
Rotacast.Frames.Edit.SequenceDown:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Down")
Rotacast.Frames.Edit.SequenceDown:SetPoint("Right", -4, 0)
Rotacast.Frames.Edit.SequenceUp = CreateFrame("Button", "Rotacast.Frames.Edit.SequenceUp", Rotacast.Frames.Edit.Header, "SecureHandlerAttributeTemplate")
Rotacast.Frames.Edit.SequenceUp:SetSize(25, 25)
Rotacast.Frames.Edit.SequenceUp:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
Rotacast.Frames.Edit.SequenceUp:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
Rotacast.Frames.Edit.SequenceUp:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Disabled")
Rotacast.Frames.Edit.SequenceUp:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down")
Rotacast.Frames.Edit.SequenceUp:SetPoint("Right", Rotacast.Frames.Edit.SequenceDown, "Left", 4, 0)
Rotacast.Frames.Options = CreateFrame("Frame", "Rotacast.Frames.Options", UIParent, "SecureHandlerShowHideTemplate")
Rotacast.Frames.Options:SetClampedToScreen(true)
Rotacast.Frames.Options:SetClampRectInsets(0, 0, 10, 0)
Rotacast.Frames.Options:SetMovable(true)
Rotacast.Frames.Options:EnableMouse(true)
Rotacast.Frames.Options:RegisterForDrag("LeftButton")
Rotacast.Frames.Options:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Marble", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = false,	 insets = {left = 10, right = 10, top = 10, bottom = 10}, tileSize = 32, edgeSize = 32}
Rotacast.Frames.Options:SetSize(495, 435)
Rotacast.Frames.Options:SetPoint("Center", -65, 0)
if (RotacastPerDB) then
if (RotacastPerDB.SetPoints.Options[1]) then Rotacast.Frames.Options:ClearAllPoints(); Rotacast.Frames.Options:SetPoint(RotacastPerDB.SetPoints.Options[1], RotacastPerDB.SetPoints.Options[2], RotacastPerDB.SetPoints.Options[3], RotacastPerDB.SetPoints.Options[4], RotacastPerDB.SetPoints.Options[5]); end
end
Rotacast.Frames.Options:SetFrameStrata("DIALOG")
Rotacast.Frames.Options.Header = Rotacast.Frames.Options:CreateTexture(nil, "ARTWORK")
Rotacast.Frames.Options.Header:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
Rotacast.Frames.Options.Header:SetSize(256, 64)
Rotacast.Frames.Options.Header:SetPoint("Top", 0, 12)
Rotacast.Frames.Options.Title = Rotacast.Frames.Options:CreateFontString("ARTWORK")
Rotacast.Frames.Options.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Options.Title:SetPoint("Top", Rotacast.Frames.Options.Header, "TOP", 0, -14)
Rotacast.Frames.Options.Title:SetText(Rotacast.Data.Title)
Rotacast.Frames.Options.Close = CreateFrame("Button", nil, Rotacast.Frames.Options, "UIPanelCloseButton")
Rotacast.Frames.Options.Close:SetSize(40, 40)
Rotacast.Frames.Options.Close:SetPoint("TopRight", -3, -3)
Rotacast.Frames.Binding = CreateFrame("Frame", nil, Rotacast.Frames.Options, "TooltipBorderedFrameTemplate")
Rotacast.Frames.Binding:SetSize(220, 197)
Rotacast.Frames.Binding:SetPoint("TopLeft", 20, -40)
Rotacast.Frames.Binding.Title = Rotacast.Frames.Binding:CreateFontString("ARTWORK")
Rotacast.Frames.Binding.Title:SetFont("Fonts\\FRIZQT__.TTF", 14)
Rotacast.Frames.Binding.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Binding.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.Binding.Title:SetPoint("Top", Rotacast.Frames.Binding, "TOP", 0, -8)
Rotacast.Frames.Binding.Title:SetText("Binding")
Rotacast.Frames.Binding.ScrollBind = Rotacast.Frames.Binding:CreateFontString("ARTWORK")
Rotacast.Frames.Binding.ScrollBind:SetFont("Fonts\\FRIZQT__.TTF", 13)
Rotacast.Frames.Binding.ScrollBind:SetFontObject("GameFontNormal")
Rotacast.Frames.Binding.ScrollBind:SetTextColor(1, 0.49, 0.04, 1)
Rotacast.Frames.Binding.ScrollBind:SetPoint("Top", 0, -30)
Rotacast.Frames.Binding.Current = Rotacast.Frames.Binding:CreateFontString("ARTWORK")
Rotacast.Frames.Binding.Current:SetFont("Fonts\\FRIZQT__.TTF", 13)
Rotacast.Frames.Binding.Current:SetFontObject("GameFontNormal")
Rotacast.Frames.Binding.Current:SetTextColor(1, 0.49, 0.04, 1)
Rotacast.Frames.Binding.Current:SetPoint("Top", 0, -50)
Rotacast.Frames.Binding.Options1 = CreateFrame("CheckButton", "BindingOptions1", Rotacast.Frames.Binding, "UICheckButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerAttributeTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.Binding.Options1:SetSize(25, 25)
Rotacast.Frames.Binding.Options1:SetPoint("TopLeft", 8, -75)
BindingOptions1Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
BindingOptions1Text:SetFontObject("GameFontNormal")
BindingOptions1Text:SetText("|cffff7d0a Toggle With Middle Button")
Rotacast.Frames.Binding.Options1:SetHitRectInsets(0,-(BindingOptions1Text:GetWidth()),0,0)
Rotacast.Frames.Binding.Options1:SetChecked(RotacastPerDB.ScrollToggle)
Rotacast.Frames.Options:Show()
if (RotacastPerDB.ScrollToggle) then
Rotacast.Frames.Binding.Options1:SetID(1)
else
Rotacast.Frames.Binding.Options1:SetID(0)
end
Rotacast.Frames.Binding.Options1:HookScript("OnClick", function(Self) 
RotacastPerDB.ScrollToggle = Self:GetChecked() 
end)
Rotacast.Functions.Tooltip(Rotacast.Frames.Binding.Options1, "Turn \"Scroll Casting\" On or Off by clicking the middle mouse button")
Rotacast.Frames.Binding.Name = CreateFrame("EditBox", nil, Rotacast.Frames.Binding, "InputBoxTemplate")
Rotacast.Frames.Binding.Name:SetTextColor(1, 0.96, 0.41, 1)
Rotacast.Frames.Binding.Name:SetSize(164, 10)
Rotacast.Frames.Binding.Name:SetPoint("Top", Rotacast.Frames.Binding.Current, "Bottom", 0, -65)
Rotacast.Functions.Tooltip(Rotacast.Frames.Binding.Name, "Type Hotkey here")
Rotacast.Frames.GenericEscapeFrame = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.Binding.ScrollSave = CreateFrame("Button", "Rotacast.Frames.Binding.ScrollSave", Rotacast.Frames.Binding, "UIPanelButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerAttributeTemplate")
Rotacast.Frames.Binding.ScrollSave:SetSize(74, 40)
Rotacast.Frames.Binding.ScrollSave:SetPoint("Top", -55, -149)
Rotacast.Frames.Binding.ScrollSave:SetText("Scroll\nCast")
Rotacast.Functions.Tooltip(Rotacast.Frames.Binding.ScrollSave, "Turn \"Scroll Casting\" On or Off")
Rotacast.Frames.Binding.KeySave = CreateFrame("Button", nil, Rotacast.Frames.Binding, "UIPanelButtonTemplate, SecureHandlerAttributeTemplate")
Rotacast.Frames.Binding.KeySave:SetSize(74, 40)
Rotacast.Frames.Binding.KeySave:SetPoint("Top", 55, -149)
Rotacast.Frames.Binding.KeySave:SetText("Set\nHotkey")
Rotacast.Functions.Tooltip(Rotacast.Frames.Binding.KeySave, "Set Hotkey")
Rotacast.Frames.Options:SetShown(RotacastPerDB.LoadShow.Binding)
Rotacast.Frames.Reset = CreateFrame("Frame", nil, Rotacast.Frames.Options, "TooltipBorderedFrameTemplate")
Rotacast.Frames.Reset:SetSize(220, 115)
Rotacast.Frames.Reset:SetPoint("Top", Rotacast.Frames.Binding, "Bottom", 0, -15)
Rotacast.Frames.Reset.Title = Rotacast.Frames.Reset:CreateFontString("ARTWORK")
Rotacast.Frames.Reset.Title:SetFont("Fonts\\FRIZQT__.TTF", 14)
Rotacast.Frames.Reset.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.Reset.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.Reset.Title:SetPoint("Top", Rotacast.Frames.Reset, "TOP", 0, -8)
Rotacast.Frames.Reset.Title:SetText("Cast Sequence Reset")
Rotacast.Frames.Reset.Options1 = CreateFrame("CheckButton", "ResetOptions1", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options1:SetSize(25, 25)
Rotacast.Frames.Reset.Options1:SetPoint("TopLeft", 8, -25)
ResetOptions1Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions1Text:SetFontObject("GameFontNormal")
ResetOptions1Text:SetText("|cffff7d0a Only During Combat")
Rotacast.Frames.Reset.Options1:SetHitRectInsets(0,-(ResetOptions1Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options1:SetChecked(RotacastPerDB.SequenceOptions.Combat)
Rotacast.Frames.Reset.Options1:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Combat = Self:GetChecked() end)
Rotacast.Functions.Tooltip(Rotacast.Frames.Reset.Options1, "Cast sequence will only reset during combat")
Rotacast.Frames.Reset.Options2 = CreateFrame("CheckButton", "ResetOptions2", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options2:SetSize(25, 25)
Rotacast.Frames.Reset.Options2:SetPoint("Top", Rotacast.Frames.Reset.Options1, "Bottom", 0, 5)
ResetOptions2Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions2Text:SetFontObject("GameFontNormal")
ResetOptions2Text:SetText("|cffff7d0a On Entering Combat")
Rotacast.Frames.Reset.Options2:SetHitRectInsets(0,-(ResetOptions2Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options2:SetChecked(RotacastPerDB.SequenceOptions.Enter)
Rotacast.Functions.Tooltip(Rotacast.Frames.Reset.Options2, "Cast sequence will reset when you enter combat")
Rotacast.Frames.Reset.Options3 = CreateFrame("CheckButton", "ResetOptions3", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options3:SetSize(25, 25)
Rotacast.Frames.Reset.Options3:SetPoint("Top", Rotacast.Frames.Reset.Options2, "Bottom", 0, 5)
ResetOptions3Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions3Text:SetFontObject("GameFontNormal")
ResetOptions3Text:SetText("|cffff7d0a On Leaving Combat")
Rotacast.Frames.Reset.Options3:SetHitRectInsets(0,-(ResetOptions3Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options3:SetChecked(RotacastPerDB.SequenceOptions.Leave)
Rotacast.Functions.Tooltip(Rotacast.Frames.Reset.Options3, "Cast sequence will reset when you leave combat")
Rotacast.Frames.Reset.Options4 = CreateFrame("CheckButton", "ResetOptions4", Rotacast.Frames.Reset, "UICheckButtonTemplate")
Rotacast.Frames.Reset.Options4:SetSize(25, 25)
Rotacast.Frames.Reset.Options4:SetPoint("Top", Rotacast.Frames.Reset.Options3, "Bottom", 0, 5)
ResetOptions4Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
ResetOptions4Text:SetFontObject("GameFontNormal")
ResetOptions4Text:SetText("|cffff7d0a On Target Switch")
Rotacast.Frames.Reset.Options4:SetHitRectInsets(0,-(ResetOptions4Text:GetWidth()),0,0)
Rotacast.Frames.Reset.Options4:SetChecked(RotacastPerDB.SequenceOptions.Switch)
Rotacast.Functions.Tooltip(Rotacast.Frames.Reset.Options4, "Cast sequence will reset when changing target")
Rotacast.Frames.CastButtonOptions = CreateFrame("Frame", nil, Rotacast.Frames.Options, "TooltipBorderedFrameTemplate")
Rotacast.Frames.CastButtonOptions:SetSize(220, 133)
Rotacast.Frames.CastButtonOptions:SetPoint("TopLeft", Rotacast.Frames.Binding, "TopRight", 17, 0)
Rotacast.Frames.CastButtonOptions.Title = Rotacast.Frames.CastButtonOptions:CreateFontString("ARTWORK")
Rotacast.Frames.CastButtonOptions.Title:SetFont("Fonts\\FRIZQT__.TTF", 14)
Rotacast.Frames.CastButtonOptions.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.CastButtonOptions.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.CastButtonOptions.Title:SetPoint("Top", Rotacast.Frames.CastButtonOptions, "TOP", 0, -8)
Rotacast.Frames.CastButtonOptions.Title:SetText("Cast Button Appearance")
Rotacast.Frames.CastButtonOptions.Options1 = CreateFrame("CheckButton", "CastButtonOptions1", Rotacast.Frames.CastButtonOptions, "UICheckButtonTemplate, SecureHandlerMouseUpDownTemplate")
Rotacast.Frames.CastButtonOptions.Options1:SetSize(25, 25)
Rotacast.Frames.CastButtonOptions.Options1:SetPoint("TopLeft", 8, -25)
CastButtonOptions1Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
CastButtonOptions1Text:SetFontObject("GameFontNormal")
CastButtonOptions1Text:SetText("|cffff7d0a Show Background Image")
Rotacast.Frames.CastButtonOptions.Options1:SetHitRectInsets(0,-(CastButtonOptions1Text:GetWidth()),0,0)
Rotacast.Frames.CastButtonOptions.Options1:SetChecked(RotacastPerDB.CastButtonOptions.Shown)
Rotacast.Functions.Tooltip(Rotacast.Frames.CastButtonOptions.Options1, "Show or Hide background")
Rotacast.Frames.CastButtonOptions.Options2 = CreateFrame("CheckButton", "CastButtonOptions2", Rotacast.Frames.CastButtonOptions, "UICheckButtonTemplate, SecureHandlerMouseUpDownTemplate")
Rotacast.Frames.CastButtonOptions.Options2:SetSize(25, 25)
Rotacast.Frames.CastButtonOptions.Options2:SetPoint("Top", Rotacast.Frames.CastButtonOptions.Options1, "Bottom", 0, 5)
CastButtonOptions2Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
CastButtonOptions2Text:SetFontObject("GameFontNormal")
CastButtonOptions2Text:SetText("|cffff7d0a Show Cooldowns")
Rotacast.Frames.CastButtonOptions.Options2:SetHitRectInsets(0,-(CastButtonOptions2Text:GetWidth()),0,0)
Rotacast.Frames.CastButtonOptions.Options2:SetChecked(RotacastPerDB.CastButtonOptions.Cooldowns)
Rotacast.Functions.Tooltip(Rotacast.Frames.CastButtonOptions.Options2, "Show or Hide cooldowns")
Rotacast.Frames.CastButtonOptions.Sizer = CreateFrame("Slider", "Rotacast.Frames.CastButtonOptions.Sizer", Rotacast.Frames.Options, "OptionsSliderTemplate")
Rotacast.Frames.CastButtonOptions.Sizer:SetSize(180, 25)
Rotacast.Frames.CastButtonOptions.Sizer:SetPoint("Top", Rotacast.Frames.CastButtonOptions, "TOP", 0, -90)
Rotacast.Frames.CastButtonOptions.Sizer:SetOrientation("Horizontal")
Rotacast.Frames.CastButtonOptions.Sizer:SetMinMaxValues(0, 15)
local text = _G[Rotacast.Frames.CastButtonOptions.Sizer:GetName() .. 'Text']
text:SetFont("Fonts\\FRIZQT__.TTF", 12)
text:SetFontObject("GameFontNormal")
text:SetText("|cffff7d0aCast Button Size")
_G[Rotacast.Frames.CastButtonOptions.Sizer:GetName() .. 'Low']:SetText('Small')
_G[Rotacast.Frames.CastButtonOptions.Sizer:GetName() .. 'High']:SetText('Big')
Rotacast.Frames.CastButtonOptions.Sizer:SetValue(RotacastPerDB.CastButtonOptions.Scale)
Rotacast.Frames.CastButtonOptions.Sizer:SetID(RotacastPerDB.CastButtonOptions.Scale)
Rotacast.Functions.Tooltip(Rotacast.Frames.CastButtonOptions.Sizer, "Resize")
Rotacast.Frames.CastingOptions = CreateFrame("Frame", nil, Rotacast.Frames.Options, "TooltipBorderedFrameTemplate")
Rotacast.Frames.CastingOptions:SetSize(220, 80)
Rotacast.Frames.CastingOptions:SetPoint("Top", Rotacast.Frames.CastButtonOptions, "Bottom", 0, -15)
Rotacast.Frames.CastingOptions.Title = Rotacast.Frames.CastingOptions:CreateFontString("ARTWORK")
Rotacast.Frames.CastingOptions.Title:SetFont("Fonts\\FRIZQT__.TTF", 14)
Rotacast.Frames.CastingOptions.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.CastingOptions.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.CastingOptions.Title:SetPoint("Top", Rotacast.Frames.CastingOptions, "TOP", 0, -8)
Rotacast.Frames.CastingOptions.Title:SetText("Casting Options")
Rotacast.Frames.CastingOptions.Options1 = CreateFrame("CheckButton", "CastingOptions1", Rotacast.Frames.CastingOptions, "UICheckButtonTemplate")
Rotacast.Frames.CastingOptions.Options1:SetSize(25, 25)
Rotacast.Frames.CastingOptions.Options1:SetPoint("TopLeft", 8, -25)
CastingOptions1Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
CastingOptions1Text:SetFontObject("GameFontNormal")
CastingOptions1Text:SetJustifyH("LEFT")
CastingOptions1Text:SetText("|cffff7d0a Use cast sequence 1 as\n combat default")
Rotacast.Frames.CastingOptions.Options1:SetHitRectInsets(0,-(CastingOptions1Text:GetWidth()),0,0)
Rotacast.Frames.CastingOptions.Options1:SetChecked(RotacastPerDB.SequenceOptions.Default)
Rotacast.Functions.Tooltip(Rotacast.Frames.CastingOptions.Options1, "Automatically switch to cast sequence 1 when entering combat")
Rotacast.Frames.CastingOptions.Options2 = CreateFrame("CheckButton", "CastingOptions2", Rotacast.Frames.CastingOptions, "UICheckButtonTemplate, SecureHandlerMouseUpDownTemplate")
Rotacast.Frames.CastingOptions.Options2:SetSize(25, 25)
Rotacast.Frames.CastingOptions.Options2:SetPoint("Top", Rotacast.Frames.CastingOptions.Options1, "Bottom", 0, 0)
CastingOptions2Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
CastingOptions2Text:SetFontObject("GameFontNormal")
CastingOptions2Text:SetText("|cffff7d0a Auto Target")
Rotacast.Frames.CastingOptions.Options2:SetHitRectInsets(0,-(CastingOptions2Text:GetWidth()),0,0)
Rotacast.Frames.CastingOptions.Options2:SetChecked(RotacastPerDB.SequenceOptions.AutoCast)
Rotacast.Functions.Tooltip(Rotacast.Frames.CastingOptions.Options2, "Turn \"Auto Targeting\" On or Off")
Rotacast.Frames.GeneralOptions = CreateFrame("Frame", nil, Rotacast.Frames.Options, "TooltipBorderedFrameTemplate")
Rotacast.Frames.GeneralOptions:SetSize(220, 135)
Rotacast.Frames.GeneralOptions:SetPoint("Top", Rotacast.Frames.CastingOptions, "Bottom", 0, -15)
Rotacast.Frames.GeneralOptions.Title = Rotacast.Frames.GeneralOptions:CreateFontString("ARTWORK")
Rotacast.Frames.GeneralOptions.Title:SetFont("Fonts\\FRIZQT__.TTF", 14)
Rotacast.Frames.GeneralOptions.Title:SetFontObject("GameFontNormal")
Rotacast.Frames.GeneralOptions.Title:SetTextColor(0, 1, 1, 1)
Rotacast.Frames.GeneralOptions.Title:SetPoint("Top", Rotacast.Frames.GeneralOptions, "TOP", 0, -8)
Rotacast.Frames.GeneralOptions.Title:SetText("General Options")
Rotacast.Frames.GeneralOptions.Options1 = CreateFrame("CheckButton", "GeneralOptions1", Rotacast.Frames.GeneralOptions, "UICheckButtonTemplate")
Rotacast.Frames.GeneralOptions.Options1:SetSize(25, 25)
Rotacast.Frames.GeneralOptions.Options1:SetPoint("TopLeft", 8, -25)
GeneralOptions1Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
GeneralOptions1Text:SetFontObject("GameFontNormal")
GeneralOptions1Text:SetText("|cffff7d0a Lock Positions")
Rotacast.Frames.GeneralOptions.Options1:SetHitRectInsets(0,-(GeneralOptions1Text:GetWidth()),0,0)
Rotacast.Frames.GeneralOptions.Options1:SetChecked(RotacastPerDB.GeneralOptions.Locked)
Rotacast.Functions.Tooltip(Rotacast.Frames.GeneralOptions.Options1, "Turn dragging of buttons and screens On or Off")
Rotacast.Frames.GeneralOptions.Options2 = CreateFrame("CheckButton", "GeneralOptions2", Rotacast.Frames.GeneralOptions, "UICheckButtonTemplate")
Rotacast.Frames.GeneralOptions.Options2:SetSize(25, 25)
Rotacast.Frames.GeneralOptions.Options2:SetPoint("Top", Rotacast.Frames.GeneralOptions.Options1, "Bottom", 0, 0)
GeneralOptions2Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
GeneralOptions2Text:SetFontObject("GameFontNormal")
GeneralOptions2Text:SetJustifyH("LEFT")
GeneralOptions2Text:SetText("|cffff7d0a Show Cast Button When\n Entering Combat")
Rotacast.Frames.GeneralOptions.Options2:SetHitRectInsets(0,-(GeneralOptions2Text:GetWidth()),0,0)
Rotacast.Frames.GeneralOptions.Options2:SetChecked(RotacastPerDB.GeneralOptions.AutoCastButton)
Rotacast.Functions.Tooltip(Rotacast.Frames.GeneralOptions.Options2, "Turn automatic showing of \"Cast Button\" when entering combat On or Off")
Rotacast.Frames.GeneralOptions.Options3 = CreateFrame("CheckButton", "GeneralOptions3", Rotacast.Frames.GeneralOptions, "UICheckButtonTemplate")
Rotacast.Frames.GeneralOptions.Options3:SetSize(25, 25)
Rotacast.Frames.GeneralOptions.Options3:SetPoint("Top", Rotacast.Frames.GeneralOptions.Options2, "Bottom", 0, -5)
GeneralOptions3Text:SetFont("Fonts\\FRIZQT__.TTF", 12)
GeneralOptions3Text:SetFontObject("GameFontNormal")
GeneralOptions3Text:SetJustifyH("LEFT")
GeneralOptions3Text:SetText("|cffff7d0a Show Cast Sequence Bar\n When Entering Combat")
Rotacast.Frames.GeneralOptions.Options3:SetHitRectInsets(0,-(GeneralOptions3Text:GetWidth()),0,0)
Rotacast.Frames.GeneralOptions.Options3:SetChecked(RotacastPerDB.GeneralOptions.AutoSequenceBar)
Rotacast.Functions.Tooltip(Rotacast.Frames.GeneralOptions.Options3, "Turn automatic showing of \"Cast Sequence Bar\" when entering combat On or Off")
Rotacast.Frames.Guide = CreateFrame("Button", nil, Rotacast.Frames.Options, "SecureHandlerClickTemplate")
Rotacast.Frames.Guide:EnableMouse(true)
Rotacast.Frames.Guide:SetSize(55, 55)
Rotacast.Frames.Guide:SetPoint("BottomRight", -240, 10)
Rotacast.Frames.Guide:SetFrameStrata("DIALOG")
Rotacast.Frames.Guide:SetAlpha(1)
Rotacast.Frames.Guide:SetHighlightTexture(136477)
local Icon = Rotacast.Frames.Guide:CreateTexture(nil, "ARTWORK")
Icon:SetTexture("Interface\\COMMON\\help-i")
Icon:SetSize(70, 70)
Icon:SetPoint("Center", 0, 0)
Rotacast.Functions.Tooltip(Rotacast.Frames.Guide, "Help screen")
Rotacast.Frames.Restore = CreateFrame("Button", nil, Rotacast.Frames.Options, "UIPanelButtonTemplate, SecureHandlerClickTemplate")
Rotacast.Frames.Restore:SetSize(174, 40)
Rotacast.Frames.Restore:SetText("Restore\nDefault Positions")
Rotacast.Frames.Restore:SetPoint("BottomLeft", 20, 17)
Rotacast.Functions.Tooltip(Rotacast.Frames.Restore, "Restore all screens and buttons to default positions")
Rotacast.Frames.GenericTargetFrame2 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericTargetFrame3 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericTargetFrame4 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame0 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame1 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame2 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame3 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame4 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame5 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame6 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame7 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame8 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame9 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame10 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame11 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame12 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericConditionFrame14 = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericShowFrame = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.Edit.Button = {}
Rotacast.Frames.Edit.ButtonAction = {}
Rotacast.Frames.Edit.ButtonAction2 = {}
Rotacast.Frames.Edit.ButtonAction3 = {}
Rotacast.Frames.Edit.ButtonAction4 = {}
Rotacast.Frames.Edit.ButtonAction5 = {}
Rotacast.Frames.GenericSkipFrame = {}
Rotacast.Frames.GenericSingleFrame = {}
local Left, Top = 19, -19
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X] = CreateFrame("Button", nil, Rotacast.Frames.Edit.Bar, "ActionButtonTemplate, SecureActionButtonTemplate, SecureHandlerMouseUpDownTemplate, SecureHandlerDragTemplate")
Rotacast.Frames.Edit.Button[X]:RegisterForClicks("AnyUp")
Rotacast.Frames.Edit.Button[X]:RegisterForDrag("LeftButton")
Rotacast.Frames.Edit.Button[X]:SetSize(35, 35)
Rotacast.Frames.Edit.Button[X]:SetPoint("TopLeft", Left, Top)
Rotacast.Frames.Edit.Button[X]:SetID(X)
Rotacast.Frames.Edit.Button[X].Border:SetTexture(130744)
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.CastButton:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.GenericConditionFrame0", Rotacast.Frames.GenericConditionFrame0)
Rotacast.Frames.GenericConditionFrame0:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.GenericConditionFrame1", Rotacast.Frames.GenericConditionFrame1)
Rotacast.Frames.GenericConditionFrame1:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.GenericConditionFrame2", Rotacast.Frames.GenericConditionFrame2)
Rotacast.Frames.GenericConditionFrame2:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.GenericConditionFrame6", Rotacast.Frames.GenericConditionFrame6)
Rotacast.Frames.GenericConditionFrame6:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.GenericConditionFrame7", Rotacast.Frames.GenericConditionFrame7)
Rotacast.Frames.GenericConditionFrame7:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.GenericConditionFrame9", Rotacast.Frames.GenericConditionFrame9)
Rotacast.Frames.GenericConditionFrame9:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.Button[X]:SetFrameRef("Rotacast.Frames.GenericConditionFrame12", Rotacast.Frames.GenericConditionFrame12)
Rotacast.Frames.GenericConditionFrame12:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.CastButton:SetFrameRef("Rotacastcool"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.ButtonAction[X] = CreateFrame("Frame", nil, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.ButtonAction[X]:SetSize(Rotacast.Frames.Edit.Button[X]:GetWidth(), Rotacast.Frames.Edit.Button[X]:GetHeight())
Rotacast.Frames.Edit.ButtonAction[X]:SetPoint("Center", 0, 0)
Rotacast.Frames.Edit.ButtonAction[X]:SetAlpha(0.5)
Rotacast.Frames.Edit.ButtonAction[X]:SetShown(false)
local Border = Rotacast.Frames.Edit.ButtonAction[X]:CreateTexture(nil, "BACKGROUND")
Border:SetTexture("Interface\\BUTTONS\\CheckButtonGlow")
Border:SetPoint("Center")
Rotacast.Frames.Edit.ButtonAction2[X] = CreateFrame("Frame", nil, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.ButtonAction2[X]:SetSize(15, 15)
Rotacast.Frames.Edit.ButtonAction2[X]:SetPoint("Center", 20, 0)
Rotacast.Frames.Edit.ButtonAction2[X]:SetShown(false)
local Border = Rotacast.Frames.Edit.ButtonAction2[X]:CreateTexture(nil, "ARTWORK")
Border:SetTexture("Interface\\ICONS\\Ability_Druid_Maul")
Border:SetSize(15, 15)
Border:SetPoint("Center")
Rotacast.Frames.Edit.ButtonAction3[X] = CreateFrame("Frame", nil, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.ButtonAction3[X]:SetSize(30, 30)
Rotacast.Frames.Edit.ButtonAction3[X]:SetPoint("Center", 0, 20)
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(false)
Rotacast.Frames.Edit.ButtonAction3[X].Border = Rotacast.Frames.Edit.ButtonAction3[X]:CreateTexture(nil, "ARTWORK")
Rotacast.Frames.Edit.ButtonAction3[X].Border:SetSize(30, 30)
Rotacast.Frames.Edit.ButtonAction3[X].Border:SetPoint("Center")
Rotacast.Frames.Edit.ButtonAction4[X] = CreateFrame("Frame", nil, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.ButtonAction4[X]:SetSize(20, 20)
Rotacast.Frames.Edit.ButtonAction4[X]:SetPoint("Center", -20, 0)
Rotacast.Frames.Edit.ButtonAction4[X]:SetShown(false)
local Border = Rotacast.Frames.Edit.ButtonAction4[X]:CreateTexture(nil, "BACKGROUND")
Border:SetTexture("Interface\\COMMON\\Indicator-Green")
Border:SetSize(20, 20)
Border:SetPoint("Center", 0, -1)
local Border2 = Rotacast.Frames.Edit.ButtonAction4[X]:CreateTexture(nil, "ARTWORK")
Border2:SetTexture("Interface\\CURSOR\\Crosshairs")
Border2:SetSize(20, 20)
Border2:SetPoint("Center")
Rotacast.Frames.Edit.ButtonAction5[X] = CreateFrame("Frame", nil, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.Edit.ButtonAction5[X]:SetSize(30, 30)
Rotacast.Frames.Edit.ButtonAction5[X]:SetPoint("Center", 0, -20)
Rotacast.Frames.Edit.ButtonAction5[X]:SetShown(false)
local Border = Rotacast.Frames.Edit.ButtonAction5[X]:CreateTexture(nil, "BACKGROUND")
Border:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Yellow")
Border:SetSize(30, 30)
Border:SetPoint("Center")
Rotacast.Frames.GenericSingleFrame[X] = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericSingleFrame[X]:SetID(X)
Rotacast.Frames.GenericSingleFrame[X]:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.GenericSingleFrame[X]:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast"..self:GetID())
Ref:SetAttribute("singlecastdone", true)
]=])
Rotacast.Frames.GenericSkipFrame[X] = CreateFrame("Cooldown", nil, Rotacast.Frames.GenericContainer, "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
Rotacast.Frames.GenericSkipFrame[X]:SetID(X)
Rotacast.Frames.GenericSkipFrame[X]:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericSkipFrame[X]:SetFrameRef("Rotacast"..X, Rotacast.Frames.Edit.Button[X])
Rotacast.Frames.GenericSkipFrame[X]:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("oldcast", Ref:GetAttribute("nextcast"))
Ref:SetAttribute("nextcast", self:GetID())
Ref:SetAttribute("castoption", "set")
]=])
Rotacast.Frames.Edit.Button[X]:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "newspell") then
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false)
local DisplayInfo, Icon
if (type(Value) == "number") then
DisplayInfo = Value
else
local ItemID = Self:GetAttribute("itemid")
if (ItemID) then
local Name, _, _, _, _, _, _, _, _, Icon, _ = GetItemInfo(ItemID)
DisplayInfo = {["Name"] = Name, ["Texture"] = Icon, ["Body"] = Self:GetAttribute("newspell"), ["ID"] = ItemID}
else
Data1, Data2, Data3 = GetMacroInfo(Self:GetAttribute("macroid"))
DisplayInfo = {["Name"] = Data1, ["Texture"] = Data2, ["Body"] = Data3}
end
end
if (type(DisplayInfo) == "table") then
Icon = DisplayInfo.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(Value)
end
Self.icon:SetTexture(Icon)
GameTooltip:Hide()
GameTooltip:SetOwner(Self, "ANCHOR_TOPLEFT")
local CastID
if (Rotacast.Data.Expansion ~= 0) then
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].ID = DisplayInfo
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].SingleCast = false
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].PetFirst = false
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].RequiresTarget = false
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].SkipCooldown = false
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].HoldCooldown = false
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].WaitUncastable = false
CastID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID
else
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].ID = DisplayInfo
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].SingleCast = false
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].PetFirst = false
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].RequiresTarget = false
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].SkipCooldown = false
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].HoldCooldown = false
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].WaitUncastable = false
CastID = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID
end
Rotacast.Frames.Edit.ButtonAction[X]:SetShown(false)
Rotacast.Frames.Edit.ButtonAction2[X]:SetShown(false)
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(false)
Rotacast.Frames.Edit.ButtonAction4[X]:SetShown(false)
Rotacast.Frames.Edit.ButtonAction5[X]:SetShown(false)
if (type(CastID) == "table") then
if (CastID.ID) then
GameTooltip:SetItemByID(CastID.ID)
else
GameTooltip:SetText(CastID.Name)
GameTooltip:AddLine("|cffff7d0a"..CastID.Body)
end
else
GameTooltip:SetSpellByID(CastID)
end
GameTooltip:Show()
if (Self:GetID() == Rotacast.Frames.CastButton:GetAttribute("nextcast")) then
Rotacast.Frames.CastButton.icon:SetTexture(Icon)
Rotacast.Functions.UpdateCooldown()
end
end
end)
Rotacast.Frames.Edit.Button[X]:SetAttribute("_ondragstart", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local SwapButton = self:GetID()
local SwapSpell = self:GetAttribute("castid")
local SwapItem = self:GetAttribute("itemid")
Ref:SetAttribute("swapbutton1", SwapButton)
Ref:SetAttribute("swapspell1", SwapSpell)
Ref:SetAttribute("swapitem1", SwapItem)
]=])
Rotacast.Frames.Edit.Button[X]:HookScript("OnDragStart", function(Self)
if (UIDROPDOWNMENU_OPEN_MENU and UIDROPDOWNMENU_OPEN_MENU.RotaMenu) then CloseDropDownMenus(); end
Rotacast.Frames.Shield:SetShown(true)
local Icon = "Interface\\CURSOR\\WorkOrders"
local DisplayID
if (Rotacast.Data.Expansion ~= 0) then DisplayID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Self:GetID()].ID; else DisplayID = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Self:GetID()].ID; end
SetCursor(Icon)
PlaySound(832)
end)
Rotacast.Frames.Edit.Button[X]:SetAttribute("_onreceivedrag", [=[
local CastID
if (kind == "spell") then
CastID = select(2, ...)
elseif (kind == "item") then
ItemID = value
CastID = "/use "..string.match(select(1, ...), "%[(.-)%]")
elseif (((kind == "petaction") and (select(1, ...)))) then
CastID = value
end
if ((kind == "spell") or (kind == "item") or ((kind == "petaction") and (select(1, ...)))) then
self:SetAttribute("castid", CastID)
self:SetAttribute("itemid", ItemID)
self:SetAttribute("spell", CastID)
self:SetAttribute("singlecast", false)
self:SetAttribute("singlecastdone", false)
self:SetAttribute("petfirst", false)
self:SetAttribute("requirestarget", false)
self:SetAttribute("skipcooldown", false)
self:SetAttribute("holdcooldown", false)
self:SetAttribute("waituncastable", false)
self:SetAttribute("newspell", CastID)
return "clear"
elseif (not kind and not value) then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local SwapButton = Ref:GetAttribute("swapbutton1")
local SwapSpell = Ref:GetAttribute("swapspell1")
local SwapItem = Ref:GetAttribute("swapitem1")
if (SwapButton and SwapSpell) then
Ref:SetAttribute("swapbutton2", self:GetID())
Ref:SetAttribute("swapspell2", self:GetAttribute("castid"))
Ref:SetAttribute("swapitem2", self:GetAttribute("itemid"))
Ref:SetAttribute("option", "swap")
end
Ref:SetAttribute("swapbutton1", nil)
Ref:SetAttribute("swapspell1", nil)
Ref:SetAttribute("swapitem1", nil)
return "clear"
end
]=])
Rotacast.Frames.Edit.Button[X]:HookScript("OnReceiveDrag", function(Self)
local Type, Data, _, _ = GetCursorInfo()
if (Type == "macro") then
if (not InCombatLockdown()) then
local CastID = GetMacroBody(Data)
Self:SetAttribute("castid", CastID)
Self:SetAttribute("itemid", nil)
Self:SetAttribute("macroid", Data)
Self:SetAttribute("newspell", CastID)
else
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to add macros while in combat")
end
end
ClearCursor()
end)
Rotacast.Frames.Edit.Button[X]:HookScript("OnDragStop", function(Self)
Rotacast.Frames.Shield:SetShown(false)
ResetCursor()
PlaySound(838)
end)
Rotacast.Frames.Edit.Button[X]:SetAttribute("_onmouseup", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
if (button == "LeftButton") then
Ref:SetAttribute("oldcast", Ref:GetAttribute("nextcast"))
Ref:SetAttribute("nextcast", self:GetID())
Ref:SetAttribute("castoption", "set")
elseif (button == "RightButton") then
local Ref2
Ref2 = self:GetFrameRef("Rotacast.Frames.GenericConditionFrame0")
Ref2:SetAttribute("buttonid", self:GetID())
Ref2 = self:GetFrameRef("Rotacast.Frames.GenericConditionFrame1")
Ref2:SetAttribute("buttonid", self:GetID())
Ref2 = self:GetFrameRef("Rotacast.Frames.GenericConditionFrame2")
Ref2:SetAttribute("buttonid", self:GetID())
Ref2 = self:GetFrameRef("Rotacast.Frames.GenericConditionFrame6")
Ref2:SetAttribute("buttonid", self:GetID())
Ref2 = self:GetFrameRef("Rotacast.Frames.GenericConditionFrame7")
Ref2:SetAttribute("buttonid", self:GetID())
Ref2 = self:GetFrameRef("Rotacast.Frames.GenericConditionFrame9")
Ref2:SetAttribute("buttonid", self:GetID())
Ref2 = self:GetFrameRef("Rotacast.Frames.GenericConditionFrame12")
Ref2:SetAttribute("buttonid", self:GetID())
end
]=])
Rotacast.Frames.Edit.Button[X]:HookScript("OnClick", function(Self, Button)
if (Button == "LeftButton") then
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false)
Rotacast.Functions.UpdateCooldown()
end
elseif (Button == "RightButton") then
if (GameTooltip:IsShown()) then GameTooltip:Hide(); end
Rotacast.Functions.DropOptions_Show(Self)
end
end)
Rotacast.Frames.Edit.Button[X]:SetScript("OnEnter", function(Self, Motion)
if (UIDROPDOWNMENU_OPEN_MENU and UIDROPDOWNMENU_OPEN_MENU.RotaMenu) then CloseDropDownMenus(); end
GameTooltip:SetOwner(Self, "ANCHOR_BOTTOMRIGHT")
local CastID
if (Rotacast.Data.Expansion ~= 0) then CastID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID; else CastID = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID; end
if (type(CastID) == "table") then
if (CastID.ID) then
GameTooltip:SetItemByID(CastID.ID)
else
GameTooltip:SetText(CastID.Name)
GameTooltip:AddLine("|cffff7d0a"..CastID.Body)
end
else
GameTooltip:SetSpellByID(CastID)
end
GameTooltip:Show()
end)
Rotacast.Frames.Edit.Button[X]:SetScript("OnLeave", function(Self, Motion)
if (not Motion) then return; end
GameTooltip:Hide()
end)
if ((X == 10) or (X == 20) or (X == 30) or (X == 40) or (X == 50) or (X == 60) or (X == 70) or (X == 80) or (X == 90) or (X == 100) or (X == 110) or (X == 120) or (X == 130) or (X == 140)) then Left, Top = 19, Top - 63; else Left = Left + 65; end
end
end
function Rotacast.Functions.CreateEvents()
Rotacast.Frames.GuideDisplay:SetScript("OnDragStart", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then Self:StartMoving(); end
end)
Rotacast.Frames.GuideDisplay:SetScript("OnDragStop", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then
Self:StopMovingOrSizing()
RotacastPerDB.SetPoints.GuideDisplay = {Self:GetPoint()}
end
end)
Rotacast.Frames.Icon:SetScript("OnDragStart", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then Self:StartMoving(); end
end)
Rotacast.Frames.Icon:SetScript("OnDragStop", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then
Self:StopMovingOrSizing()
RotacastPerDB.SetPoints.Icon = {Self:GetPoint()}
end
end)
Rotacast.Frames.Icon:SetScript("OnEnter", function(Self, Motion)
if (not Motion) then return; end
Rotacast.Functions.IconMessage(Self)
end)
Rotacast.Frames.Icon:SetScript("OnLeave", function(Self, Motion)
if (not Motion) then return; end
GameTooltip:Hide()
end)
Rotacast.Frames.Icon:SetAttribute("_onclick", [=[
local Ref
if (button == "LeftButton") then Ref = self:GetFrameRef("Rotacast.Frames.CastButton"); elseif (button == "RightButton") then Ref = self:GetFrameRef("Rotacast.Frames.Edit.Bar"); elseif (button == "MiddleButton") then Ref = self:GetFrameRef("Rotacast.Frames.Hotkey"); end
if (Ref) then
if (Ref:IsShown()) then
if (button ~= "RightButton") then Ref:Hide(); end
else
if (button ~= "RightButton") then Ref:Show(); end
end
end
]=])
Rotacast.Frames.Icon:HookScript("OnClick", function(Self, Button)
if (Button == "RightButton") then
if (Rotacast.Frames.Edit.Bar:IsShown()) then
if (UIDROPDOWNMENU_OPEN_MENU and UIDROPDOWNMENU_OPEN_MENU.RotaMenu) then
CloseDropDownMenus()
else
if (InCombatLockdown()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame2, 1, 1, true)
else
Rotacast.Frames.Edit.Bar:Hide()
Rotacast.Frames.Edit.Bar:GetParent():Hide()
end
end
else
if (InCombatLockdown()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame2, 1, 1, true)
else
Rotacast.Frames.Edit.Bar:Show()
Rotacast.Frames.Edit.Bar:GetParent():Show()
end
end
end
if (Self:IsMouseOver()) then
GameTooltip:Hide()
Rotacast.Functions.IconMessage(Self)
end
end)
Rotacast.Frames.GenericFrame:HookScript("OnShow", function(Self) CooldownFrame_Set(Self, _, _, false) end)
Rotacast.Frames.GenericFrame:SetAttribute("_onshow", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local NextCast = Ref:GetAttribute("nextcast")
if (not NextCast) then return; end
local Ref2
for i = 1, Ref:GetAttribute("numbuttons") do
Ref2 = Ref:GetFrameRef("Rotacast"..i)
Ref2:SetAttribute("singlecastdone", false)
end
Ref:SetAttribute("oldcast", NextCast)
Ref:SetAttribute("nextcast", 1)
Ref:SetAttribute("castoption", "set")
]=])
Rotacast.Frames.GenericSlashFrame1:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
if (Ref:IsShown()) then
Ref:Hide()
else
Ref:Show()
end
]=])
Rotacast.Frames.GenericSlashFrame2:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.Edit.Bar")
if (Ref:IsShown()) then
Ref:Hide()
Ref:GetParent():Hide()
else
Ref:Show()
Ref:GetParent():Show()
end
]=])
Rotacast.Frames.GenericSlashFrame3:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.Hotkey")
if (Ref:IsShown()) then
Ref:Hide()
else
Ref:Show()
end
]=])
Rotacast.Frames.CastButton:SetScript("OnDragStart", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then Self:StartMoving(); end
end)
Rotacast.Frames.CastButton:SetScript("OnDragStop", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then
Self:StopMovingOrSizing()
RotacastPerDB.SetPoints.CastButton = {Self:GetPoint()}
end
end)
Rotacast.Frames.CastButton:HookScript("OnClick", function(Self, Button)
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false)
Rotacast.Functions.UpdateCooldown()
end
end)
Rotacast.Frames.CastButton:HookScript("OnMouseUp", function(Self, Button)
if ((Button == "LeftButton") and (Self:GetAttribute("postcheck"))) then
if (Rotacast.Functions.Get_UsableItem(Self:GetAttribute("nextcast"))) then
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame11, 1, 1, true)
else
Rotacast.Functions.Set_SingleCastdone()
local ButtonID = Rotacast.Functions.Cooldown_Skip()
if (ButtonID) then
CooldownFrame_Set(Rotacast.Frames.GenericSkipFrame[ButtonID], 1, 1, true)
end
end
end
end)
Rotacast.Frames.CastButton:SetAttribute("_onmouseup", [=[
local NextCast = self:GetAttribute("nextcast")
local NumButtons = self:GetAttribute("numbuttons")
if (button == "LeftButton") then
self:SetAttribute("*type1", nil)
self:SetAttribute("postcheck", false)
if (self:GetAttribute("numbuttons") ~= 0) then
self:SetAttribute("validcast", true)
local Ref = self:GetFrameRef("Rotacast"..NextCast)
if (self:GetAttribute("autotarget")) then
self:SetAttribute("validcast", false)
local Ref2 = self:GetFrameRef("Rotacast.Frames.GenericTargetFrame2")
Ref2:Show()
end
if (self:GetAttribute("validcast")) then
if (Ref:GetAttribute("petfirst") == true) then
self:SetAttribute("validcast", false)
local Ref2 =  self:GetFrameRef("Rotacast.Frames.GenericConditionFrame3")
Ref2:Show()
end
end
if (self:GetAttribute("validcast")) then
if (Ref:GetAttribute("requirestarget") == true) then
self:SetAttribute("validcast", false)
local Ref2 =  self:GetFrameRef("Rotacast.Frames.GenericConditionFrame10")
Ref2:Show()
end
end
if (self:GetAttribute("validcast")) then
if (Ref:GetAttribute("singlecast")) then
if (Ref:GetAttribute("singlecastdone")) then
self:SetAttribute("validcast", false)
local Ref2 =  self:GetFrameRef("Rotacast.Frames.GenericConditionFrame8")
Ref2:Show()
end
end
end
if (self:GetAttribute("validcast")) then
if (Ref:GetAttribute("holdcooldown")) then
local Ref2  = self:GetFrameRef("RotacastCooldown")
if (Ref2:IsVisible()) then self:SetAttribute("validcast", false); else self:SetAttribute("validcast", true); end
elseif (Ref:GetAttribute("skipcooldown")) then
local Ref2  = self:GetFrameRef("RotacastCooldown")
if (Ref2:IsVisible()) then
self:SetAttribute("validcast", false)
local Ref2 =  self:GetFrameRef("Rotacast.Frames.GenericConditionFrame8")
Ref2:Show()
else
self:SetAttribute("validcast", true)
end
end
end
end
elseif (button =="RightButton") then
if (not NextCast) then return; end
local Ref
for i = 1,NumButtons do
Ref = self:GetFrameRef("Rotacast"..i)
Ref:SetAttribute("singlecastdone", false)
end
self:SetAttribute("oldcast", NextCast)
self:SetAttribute("nextcast", 1)
self:SetAttribute("castoption", "set")
elseif (button == "MiddleButton") then
if (self:IsShown()) then self:Hide(); end
end
if (button == "LeftButton") then
self:SetAttribute("catcherror", false)
local ValidCast = self:GetAttribute("validcast")
if (not ValidCast) then return; end
self:SetAttribute("validcast", false)
self:SetAttribute("moveon", nil)
NextCast = self:GetAttribute("nextcast")
if (NextCast) then
self:SetAttribute("postcheck", true)
local Ref = self:GetFrameRef("Rotacast"..NextCast)
local CastID = Ref:GetAttribute("castid")
local CastName = self:GetAttribute("SpellList"..CastID)
local CastType
if (type(CastID) == "string") then
CastType = CastID
self:SetAttribute("*type1", "macro")
self:SetAttribute("macrotext", CastType)
else	
if CastName then
CastType = "/cast "..CastName
self:SetAttribute("*type1", "macro")
self:SetAttribute("macrotext", CastType)
else
CastType = CastID
self:SetAttribute("*type1", "spell")
self:SetAttribute("spell", CastType)
end
end
self:SetAttribute("oldcast", NextCast)
end
end
]=])
Rotacast.Frames.CastButton:HookScript("OnUpdate", function(Self)
if (Self.NormalTexture:IsVisible()) then Self.NormalTexture:Hide(); end
local NextCast =Self:GetAttribute("nextcast")
if (NextCast) then
local CastID = Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("castid")
if (CastID) then
local SpellID, IsMacro
if (type(CastID) == "string") then
IsMacro = Rotacast.Functions.FindMacro(CastID)
if (IsMacro) then
SpellID, _, _ =  GetMacroSpell(IsMacro)
if (SpellID and type(SpellID) ~= "table") then
Rotacast.Functions.UpdateRangeSpell(select(1,  GetSpellInfo(SpellID)))
end
else
SpellID = Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("itemid")
if (SpellID) then
if (type(SpellID) == "table") then
if (SpellID.ID) then
Start, Duration, _ = GetItemCooldown(SpellID.ID)
end
else
Start, Duration, _ = GetItemCooldown(SpellID)
end
end
end
else
if (type(SpellID) ~= "table") then Rotacast.Functions.UpdateRangeSpell(select(1,  GetSpellInfo(CastID))); end
end
end
end
end)
Rotacast.Frames.CastButton:SetAttribute("_onreceivedrag", [=[
local CastID, ItemID, PetAction
if (kind == "spell") then
CastID = select(2, ...)
elseif (kind == "item") then
ItemID = value
CastID = "/use "..string.match(select(1, ...), "%[(.-)%]")
elseif (kind == "petaction") then
if (select(1, ...)) then 
CastID = value
PetAction = true
else
PetAction = false
end
end
local NumButtons = self:GetAttribute("numbuttons")
if (NumButtons >= 100) then
print("|cffff7d0a".."Rotacast", "|cffffe00a".."Spell Queue Is Full!")
return "clear"
end
if (kind == "spell" or kind == "item" or (kind == "petaction" and PetAction)) then
NumButtons = NumButtons + 1
local Ref = self:GetFrameRef("Rotacast"..NumButtons)
Ref:SetAttribute("castid", CastID)
Ref:SetAttribute("itemid", ItemID)
Ref:Show()
local Ref = self:GetFrameRef("Rotacast.Frames.Edit.Bar")
Ref:SetAttribute("numbuttons", NumButtons)
self:SetAttribute("numbuttons", NumButtons)
self:SetAttribute("itemid", ItemID)
self:SetAttribute("newspell", CastID)
self:SetAttribute("option", "add")
end
]=])
Rotacast.Frames.CastButton:HookScript("OnReceiveDrag", function(Self)
local Type, Data, _, _ = GetCursorInfo()
if (Type == "macro") then
if (not InCombatLockdown()) then
local NumButtons = Self:GetAttribute("numbuttons")
if (NumButtons >= 100) then
print("|cffff7d0a".."Rotacast", "|cffffe00a".."Spell Queue Is Full!")
return
end
NumButtons = NumButtons + 1
local Ref = Rotacast.Frames.Edit.Button[NumButtons]
local CastID = GetMacroBody(Data)
Ref:SetAttribute("castid", CastID)
Ref:SetAttribute("itemid", nil)
Ref:Show()
Rotacast.Frames.Edit.Bar:SetAttribute("numbuttons", NumButtons)
Self:SetAttribute("numbuttons", NumButtons)
Self:SetAttribute("spellid", Data)
Self:SetAttribute("itemid", nil)
Self:SetAttribute("newspell", CastID)
Self:SetAttribute("option", "add")
else
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to add macros while in combat")
end
end
ClearCursor()
end)
Rotacast.Frames.CastButton:SetAttribute("_onattributechanged", [=[
if (name == "option") then
if (value == "add") then
if (not self:GetAttribute("nextcast")) then
self:SetAttribute("nextcast", 1)
self:SetAttribute("castoption", "set")
end
elseif (value == "swap") then
local SwapButton1 = self:GetAttribute("swapbutton1")
local SwapSpell1 = self:GetAttribute("swapspell1")
local SwapItem1 = self:GetAttribute("swapitem1")
local SwapButton2 = self:GetAttribute("swapbutton2")
local SwapSpell2 = self:GetAttribute("swapspell2")
local SwapItem2 = self:GetAttribute("swapitem2")
local Ref1 = self:GetFrameRef("Rotacast"..SwapButton1)
local Ref2 = self:GetFrameRef("Rotacast"..SwapButton2)
local Single1, Single2, Done1, Done2 = Ref1:GetAttribute("singlecast"), Ref2:GetAttribute("singlecast"), Ref1:GetAttribute("singlecastdone"), Ref2:GetAttribute("singlecastdone")
local PetFirst1, PetFirst2 = Ref1:GetAttribute("petfirst"), Ref2:GetAttribute("petfirst")
local RequiresTarget1, RequiresTarget2 = Ref1:GetAttribute("requirestarget"), Ref2:GetAttribute("requirestarget")
local SkipCooldown1, SkipCooldown2 = Ref1:GetAttribute("skipcooldown"), Ref2:GetAttribute("skipcooldown")
local HoldCooldown1, HoldCooldown2 = Ref1:GetAttribute("holdcooldown"), Ref2:GetAttribute("holdcooldown")
local WaitUncastable1, WaitUncastable2 = Ref1:GetAttribute("waituncastable"), Ref2:GetAttribute("waituncastable")
Ref1:SetAttribute("castid", SwapSpell2)
Ref1:SetAttribute("itemid", SwapItem2)
Ref1:SetAttribute("singlecast", Single2)
Ref1:SetAttribute("singlecastdone", Done2)
Ref1:SetAttribute("petfirst", PetFirst2)
Ref1:SetAttribute("requirestarget", RequiresTarget2)
Ref1:SetAttribute("skipcooldown", SkipCooldown2)
Ref1:SetAttribute("holdcooldown", HoldCooldown2)
Ref1:SetAttribute("waituncastable", WaitUncastable2)
Ref2:SetAttribute("castid", SwapSpell1)
Ref2:SetAttribute("itemid", SwapItem1)
Ref2:SetAttribute("singlecast", Single1)
Ref2:SetAttribute("singlecastdone", Done1)
Ref2:SetAttribute("petfirst", PetFirst1)
Ref2:SetAttribute("requirestarget", RequiresTarget1)
Ref2:SetAttribute("skipcooldown", SkipCooldown1)
Ref2:SetAttribute("holdcooldown", HoldCooldown1)
Ref2:SetAttribute("waituncastable", WaitUncastable1)
elseif (value == "delete") then
local DeleteID = self:GetAttribute("deleteid")
local NextCast = self:GetAttribute("nextcast")
local NumButtons = self:GetAttribute("numbuttons")
local Ref
local Index = 0
for X = 1, NumButtons do
Ref = self:GetFrameRef("Rotacast"..X)
if (X ~= DeleteID) then
Index = Index + 1
local Ref2 = self:GetFrameRef("Rotacast"..Index)
Ref2:SetAttribute("castid", Ref:GetAttribute("castid"))
Ref2:SetAttribute("itemid", Ref:GetAttribute("itemid"))
Ref2:SetAttribute("singlecast", Ref:GetAttribute("singlecast"))
Ref2:SetAttribute("singlecastdone", Ref:GetAttribute("singlecastdone"))
Ref2:SetAttribute("petfirst", Ref:GetAttribute("petfirst"))
Ref2:SetAttribute("requirestarget", Ref:GetAttribute("requirestarget"))
Ref2:SetAttribute("skipcooldown", Ref:GetAttribute("skipcooldown"))
Ref2:SetAttribute("holdcooldown", Ref:GetAttribute("holdcooldown"))
Ref2:SetAttribute("waituncastable", Ref:GetAttribute("waituncastable"))
end
end
Ref:SetAttribute("singlecast", false)
Ref:SetAttribute("singlecastdone", false)
Ref:SetAttribute("petfirst", false)
Ref:SetAttribute("requirestarget", false)
Ref:SetAttribute("skipcooldown", false)
Ref:SetAttribute("holdcooldown", false)
Ref:SetAttribute("waituncastable", false)
Ref:Hide()
NumButtons = NumButtons - 1
local Ref = self:GetFrameRef("Rotacast.Frames.Edit.Bar")
self:SetAttribute("numbuttons", NumButtons)
Ref:SetAttribute("numbuttons", NumButtons)
local Clicked, First = DeleteID
if (Clicked > NextCast) then
First = NextCast
elseif (Clicked < NextCast) then
First = NextCast - 1
elseif (Clicked == NextCast) then
if (NextCast >= NumButtons) then First = NumButtons; else First = NextCast; end
end
if (First == 0) then First = nil; end
self:SetAttribute("oldcast", NextCast)
self:SetAttribute("nextcast", First)
self:SetAttribute("castoption", "delete")
end
elseif (name == "hotkeybinding" and value) then
self:SetBindingClick(false, value, self:GetName(), "LeftButton")
end
]=])
if (Rotacast.Data.Expansion ~= 0) then Rotacast.Frames.CastButton:SetAttribute("hotkeybinding", RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Binding); else Rotacast.Frames.CastButton:SetAttribute("hotkeybinding", RotacastPerDB.SpecData.HotkeyData.Binding); end
Rotacast.Frames.CastButton:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "option") then
if (Value == "add") then
local GetSpell, AddSpell = Self:GetAttribute("newspell")
if (type(GetSpell) == "number") then
AddSpell = GetSpell
else
local ItemID = Self:GetAttribute("itemid")
if (ItemID) then
local Name, _, _, _, _, _, _, _, _, Icon, _ = GetItemInfo(ItemID)
AddSpell = {["Name"] = Name, ["Texture"] = Icon, ["Body"] = Self:GetAttribute("newspell"), ["ID"] = ItemID}
else
Data1, Data2, Data3 = GetMacroInfo(Self:GetAttribute("spellid"))
AddSpell = {["Name"] = Data1, ["Texture"] = Data2, ["Body"] = Data3}
end
end
if (Rotacast.Data.Expansion ~= 0) then
table.insert(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current], {["ID"] = AddSpell, ["SingleCast"] = false, ["PetFirst"] = false, ["SkipCooldown"] = false, ["HoldCooldown"] = false, ["RequiresTarget"] = false, ["WaitUncastable"] = false})
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] == 1) then
local DisplayID, Icon = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][1].ID
if (type(DisplayID) == "table") then
Icon = DisplayID.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID)
end
Self.icon:SetTexture(Icon)
Rotacast.Frames.Edit.Button[1].Border:Show()
end
else
table.insert(RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current], {["ID"] = AddSpell, ["SingleCast"] = false, ["PetFirst"] = false, ["SkipCooldown"] = false, ["HoldCooldown"] = false, ["RequiresTarget"] = false, ["WaitUncastable"] = false})
if (#RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current] == 1) then
local DisplayID, Icon = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][1].ID
if (type(DisplayID) == "table") then
Icon = DisplayID.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID)
end
Self.icon:SetTexture(Icon)
Rotacast.Frames.Edit.Button[1].Border:Show()
end
end
elseif (Value == "swap") then
local SwapButton1 = Self:GetAttribute("swapbutton1")
local SwapSpell1 = Self:GetAttribute("swapspell1")
local SwapItem1 = Self:GetAttribute("swapitem1")
local SwapButton2 = Self:GetAttribute("swapbutton2")
local SwapSpell2 = Self:GetAttribute("swapspell2")
local SwapItem2 = Self:GetAttribute("swapitem2")
if (Rotacast.Data.Expansion ~= 0) then
local Swap1, Swap2 = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton1], RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2]
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton1] = Swap2
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2] = Swap1
else
local Swap1, Swap2 = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][SwapButton1], RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][SwapButton2]
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][SwapButton1] = Swap2
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][SwapButton2] = Swap1
end
GameTooltip:Hide()
GameTooltip:SetOwner(Rotacast.Frames.Edit.Button[SwapButton2], "ANCHOR_TOPLEFT")
local CastID = SwapSpell1
if (type(SwapSpell1) == "string") then
if (SwapItem1) then
GameTooltip:SetItemByID(SwapItem1)
else
if (Rotacast.Data.Expansion ~= 0) then
GameTooltip:SetText(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2].ID.Name)
GameTooltip:AddLine("|cffff7d0a"..RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][SwapButton2].ID.Body)
else
GameTooltip:SetText(RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][SwapButton2].ID.Name)
GameTooltip:AddLine("|cffff7d0a"..RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][SwapButton2].ID.Body)
end
end
else
GameTooltip:SetSpellByID(SwapSpell1)
end
CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false)
Rotacast.Functions.UpdateCooldown()
GameTooltip:Show()
elseif (Value == "delete") then
GameTooltip:Hide()
if (Rotacast.Data.Expansion ~= 0) then table.remove(RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current], Self:GetAttribute("deleteid")); else table.remove(RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current], Self:GetAttribute("deleteid")); end
PlaySound(684)
end
local CastIcon
local length
if (Rotacast.Data.Expansion ~= 0) then length = #RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current]; else length = #RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current]; end
for X = 1, length do
local DisplayID, Icon
if (Rotacast.Data.Expansion ~= 0) then DisplayID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][X].ID; else DisplayID = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][X].ID; end
if (type(DisplayID) == "table") then
Icon = DisplayID.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID)
end
Rotacast.Frames.Edit.Button[X].icon:SetTexture(Icon)
if (Rotacast.Frames.Edit.Button[X].Border:IsVisible()) then CastIcon = Rotacast.Frames.Edit.Button[X].icon:GetTexture(); end
Rotacast.Frames.Edit.ButtonAction[X]:SetShown(Rotacast.Frames.Edit.Button[X]:GetAttribute("singlecast"))
Rotacast.Frames.Edit.ButtonAction2[X]:SetShown(Rotacast.Frames.Edit.Button[X]:GetAttribute("petfirst"))
if (Rotacast.Frames.Edit.Button[X]:GetAttribute("skipcooldown")) then
Rotacast.Frames.Edit.ButtonAction3[X].Border:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Green")
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(true)
elseif (Rotacast.Frames.Edit.Button[X]:GetAttribute("holdcooldown")) then
Rotacast.Frames.Edit.ButtonAction3[X].Border:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Red")
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(true)
else
Rotacast.Frames.Edit.ButtonAction3[X]:SetShown(false)
end
Rotacast.Frames.Edit.ButtonAction4[X]:SetShown(Rotacast.Frames.Edit.Button[X]:GetAttribute("requirestarget"))
Rotacast.Frames.Edit.ButtonAction5[X]:SetShown(Rotacast.Frames.Edit.Button[X]:GetAttribute("waituncastable"))
end
if (Value ~= "add") then Self.icon:SetTexture(CastIcon or 134400); end
elseif (Name == "castoption") then
if (Value == "set") then
if (Rotacast.Data.Expansion ~= 0) then
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] == 0) then return; end
else
if (#RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current] == 0) then return; end
end
local Index = Self:GetAttribute("nextcast")
local DisplayID, Icon
if (Rotacast.Data.Expansion ~= 0) then DisplayID = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][Index].ID; else DisplayID = RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][Index].ID; end
if (type(DisplayID) == "table") then
Icon = DisplayID.Texture
else
_, _, Icon, _, _, _, _ = GetSpellInfo(DisplayID)
end
Self.icon:SetTexture(Icon)
local OldCast = Self:GetAttribute("oldcast")
if (OldCast) then Rotacast.Frames.Edit.Button[OldCast].Border:Hide(); end
Rotacast.Frames.Edit.Button[Index].Border:Show()
Rotacast.Functions.UpdateCooldown()
elseif (Value == "delete") then
local Index = Self:GetAttribute("nextcast")
local OldCast = Self:GetAttribute("oldcast")
if (OldCast) then Rotacast.Frames.Edit.Button[OldCast].Border:Hide(); end
if (Index) then Rotacast.Frames.Edit.Button[Index].Border:Show(); end
Rotacast.Functions.UpdateCooldown()
end
end
end)
Rotacast.Frames.CastButton:HookScript("OnShow", function() RotacastPerDB.LoadShow.Cast = true; PlaySound(839) end)
Rotacast.Frames.CastButton:HookScript("OnHide", function() RotacastPerDB.LoadShow.Cast = false; PlaySound(840) end)
Rotacast.Frames.Edit.Header:SetScript("OnDragStart", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then Self:StartMoving(); end
end)
Rotacast.Frames.Edit.Header:SetScript("OnDragStop", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then
Self:StopMovingOrSizing()
RotacastPerDB.SetPoints.Header = {Self:GetPoint()}
end
end)
Rotacast.Frames.Edit.Bar:SetScript("OnDragStart", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then Self:StartMoving(); end
end)
Rotacast.Frames.Edit.Bar:SetScript("OnDragStop", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then Self:StopMovingOrSizing(); end
end)
Rotacast.Frames.Edit.Bar:SetAttribute("_onattributechanged", [=[
if (name == "loadshow") then
local Ref = self:GetFrameRef("Rotacast.Frames.Icon")
Ref:SetBindingClick(false, "ESCAPE", Ref:GetName(), "RightButton")
end
if (name == "numbuttons") then
if (value ~= 0) then
local Height, Width = math.ceil(value / 10)
if (value > 10) then Width = 10; else Width = value; end
self:SetWidth((Width * 65) + 7); self:SetHeight((Height * 63) + 9)
end
end
]=])
Rotacast.Frames.Edit.Bar:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "numbuttons") then
local Height, Width = Self:GetHeight()
if (Value < 5) then Width = 0; else Width = (Self:GetWidth() / 2) - 100; end
Rotacast.Frames.Edit.Header:SetClampedToScreen(true)
Rotacast.Frames.Edit.Header:SetClampRectInsets(-Width, Width, 0, -Height)
end
end)
Rotacast.Frames.Edit.Bar:SetAttribute("_onshow", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.Icon")
Ref:SetBindingClick(false, "ESCAPE", Ref:GetName(), "RightButton")
]=])
Rotacast.Frames.Edit.Bar:HookScript("OnShow", function() RotacastPerDB.LoadShow.Sequence = true; PlaySound(839) end)
Rotacast.Frames.Edit.Bar:HookScript("OnHide", function()
GameTooltip:Hide()
CloseDropDownMenus()
RotacastPerDB.LoadShow.Sequence = false
PlaySound(840)
end)
Rotacast.Frames.Edit.Bar:SetAttribute("_onhide", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.Icon")
Ref:ClearBinding("ESCAPE")
]=])
Rotacast.Frames.Edit.CreateSequence:SetScript("OnClick", function(Self)
if (InCombatLockdown()) then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to create/delete sequences while in combat")
return
end
ToggleDropDownMenu(1, nil, Rotacast.Frames.Edit.CreateMenu, Self, -7, 0)
end)
Rotacast.Frames.Edit.SequenceDown:SetScript("OnClick", function()
if (InCombatLockdown()) then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to switch sequences while in combat")
return
end
if (Rotacast.Data.Expansion ~= 0) then
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current == 1) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max; else RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current - 1; end
else
if (RotacastPerDB.SpecData.Current == 1) then RotacastPerDB.SpecData.Current = RotacastPerDB.SpecData.Max; else RotacastPerDB.SpecData.Current = RotacastPerDB.SpecData.Current - 1; end
end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
Rotacast.Frames.Edit.ButtonAction[X]:Hide()
Rotacast.Frames.Edit.ButtonAction2[X]:Hide()
Rotacast.Frames.Edit.ButtonAction3[X]:Hide()
Rotacast.Frames.Edit.ButtonAction4[X]:Hide()
Rotacast.Frames.Edit.ButtonAction5[X]:Hide()
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecast", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecastdone", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("petfirst", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("requirestarget", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("skipcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("holdcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("waituncastable", false)
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end)
Rotacast.Frames.Edit.SequenceDown:SetAttribute("_onattributechanged", [=[
self:SetBindingClick(false, "LCTRL-DOWN", self:GetName(), "LeftButton")
self:SetBindingClick(false, "RCTRL-DOWN", self:GetName(), "LeftButton")
]=])
Rotacast.Frames.Edit.SequenceUp:SetScript("OnClick", function()
if (InCombatLockdown()) then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to switch sequences while in combat")
return
end
if (Rotacast.Data.Expansion ~= 0) then
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current == RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Max) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = 1; else RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current + 1; end
else
if (RotacastPerDB.SpecData.Current == RotacastPerDB.SpecData.Max) then RotacastPerDB.SpecData.Current = 1; else RotacastPerDB.SpecData.Current = RotacastPerDB.SpecData.Current + 1; end
end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
Rotacast.Frames.Edit.ButtonAction[X]:Hide()
Rotacast.Frames.Edit.ButtonAction2[X]:Hide()
Rotacast.Frames.Edit.ButtonAction3[X]:Hide()
Rotacast.Frames.Edit.ButtonAction4[X]:Hide()
Rotacast.Frames.Edit.ButtonAction5[X]:Hide()
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecast", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecastdone", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("petfirst", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("requirestarget", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("skipcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("holdcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("waituncastable", false)
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end)
Rotacast.Frames.Edit.SequenceUp:SetAttribute("_onattributechanged", [=[
self:SetBindingClick(false, "LCTRL-UP", self:GetName(), "LeftButton")
self:SetBindingClick(false, "RCTRL-UP", self:GetName(), "LeftButton")
]=])
Rotacast.Frames.Options:SetScript("OnDragStart", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then Self:StartMoving(); end
end)
Rotacast.Frames.Options:SetScript("OnDragStop", function(Self)
if (not RotacastPerDB.GeneralOptions.Locked) then
Self:StopMovingOrSizing()
RotacastPerDB.SetPoints.Options = {Self:GetPoint()}
end
end)
Rotacast.Frames.Options:SetAttribute("_onhide", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.GuideDisplay")
if (Ref:IsShown()) then Ref:Hide(); end
]=])
Rotacast.Frames.Binding.Options1:SetAttribute("_onmouseup", [=[
local ID = self:GetID()
local Ref = self:GetFrameRef("Rotacast.Frames.Binding.ScrollSave")
if (ID == 1) then
Ref:ClearBinding("BUTTON3")
Ref:ClearBinding("BUTTON3")
self:SetID(0)
elseif (ID == 0) then
Ref:SetBindingClick(false, "BUTTON3", Ref:GetName(), "LeftButton")
Ref:SetBindingClick(false, "BUTTON3", Ref:GetName(), "LeftButton")
self:SetID(1)
end
]=])
Rotacast.Frames.Binding.Name:SetScript("OnEscapePressed", function()
if (UIDROPDOWNMENU_OPEN_MENU and UIDROPDOWNMENU_OPEN_MENU.RotaMenu) then
CloseDropDownMenus()
else
CooldownFrame_Set(Rotacast.Frames.GenericEscapeFrame, 1, 1, true)
end
end)
Rotacast.Frames.GenericEscapeFrame:SetAttribute("_onshow", [=[
self:Hide()
self:GetFrameRef("Rotacast.Frames.Options"):Hide()
]=])
Rotacast.Frames.Binding.Name:SetScript("OnKeyDown", function(Self, Key)
local Mod, Char
if (Key ~= "DELETE" and Key ~= "BACKSPACE" and Key ~= "ESCAPE") then
if (IsLeftShiftKeyDown()) then
Mod, Char = "LSHIFT-", Key
Self.HotkeyName = "Left Shift + "
elseif (IsLeftAltKeyDown()) then
Mod, Char = "LALT-", Key
Self.HotkeyName = "Left Alt + "
elseif (IsLeftControlKeyDown()) then
if (Key == "UP" or Key == "DOWN") then return; end
Mod, Char = "LCTRL-", Key
Self.HotkeyName = "Left Ctrl + "
elseif (IsRightShiftKeyDown()) then
Mod, Char = "RSHIFT-", Key
Self.HotkeyName = "Right Shift + "
elseif (IsRightAltKeyDown()) then
Mod, Char = "RALT-", Key
Self.HotkeyName = "Right Alt + "
elseif (IsRightControlKeyDown()) then
if (Key == "UP" or Key == "DOWN") then return; end
Mod, Char = "RCTRL-", Key
Self.HotkeyName = "Right Ctrl + "
else
Mod, Char = nil, Key
Self.HotkeyName = Char
end
if (Char == "LSHIFT" or Char == "LALT" or Char == "LCTRL" or Char == "RSHIFT" or Char == "RALT" or Char == "RCTRL") then Mod, Char = nil, nil; end
else
Mod, Char = nil, nil
end
if (not Mod and not Char) then
Self.HotkeyBinding = nil
Self.HotkeyName = nil
elseif (not Mod and Char) then
Self.HotkeyBinding = Char
Self.HotkeyName = Char
else
Self.HotkeyBinding = Mod..Char
Self.HotkeyName = Self.HotkeyName..Char
end
if (Self.HotkeyName) then
Self:SetMaxLetters(#Self.HotkeyName)
Self:SetText(Self.HotkeyName)
else
Self:SetText("")
end
end)
Rotacast.Frames.Binding.ScrollSave:SetAttribute("_onmouseup", [=[
local ScrollBind = self:GetAttribute("rotacastperdb.scrollbind")
if (ScrollBind == "On") then ScrollBind = "Off"; elseif (ScrollBind == "Off") then ScrollBind = "On"; end
self:SetAttribute("rotacastperdb.scrollbind", ScrollBind)
]=])
Rotacast.Frames.Binding.ScrollSave:SetAttribute("_onattributechanged", [=[
if (name == "rotacastperdb.scrollbind") then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
if (value == "On") then
Ref:SetBindingClick(false, "MOUSEWHEELUP", Ref:GetName(), "LeftButton")
Ref:SetBindingClick(false, "MOUSEWHEELDOWN", Ref:GetName(), "LeftButton")
elseif (value == "Off") then
Ref:ClearBinding("MOUSEWHEELUP")
Ref:ClearBinding("MOUSEWHEELDOWN")
end
Ref = self:GetFrameRef("Rotacast.Frames.Binding.Options1")
local ID = Ref:GetID()
if (ID == 1) then
self:SetBindingClick(false, "BUTTON3", self:GetName(), "LeftButton")
self:SetBindingClick(false, "BUTTON3", self:GetName(), "LeftButton")
elseif (ID == 0) then
self:ClearBinding("BUTTON3")
self:ClearBinding("BUTTON3")
end
end
]=])
Rotacast.Frames.Binding.ScrollSave:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "rotacastperdb.scrollbind") then
RotacastPerDB.ScrollBind = Value
Rotacast.Frames.Binding.ScrollBind:SetText("Scroll Cast: |cffffe00a"..RotacastPerDB.ScrollBind)
if (RotacastPerDB.ScrollBind == "On") then UIErrorsFrame:AddMessage("Scroll Cast On!", 1.0, 0.5, 0.0, 3); else UIErrorsFrame:AddMessage("Scroll Cast Off!", 1.0, 0.5, 0.0, 3); end
end
end)
Rotacast.Frames.Binding.KeySave:HookScript("OnClick", function(Self)
if (InCombatLockdown()) then
print("|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cffffe00a".."Unable to modify hotkey while in combat")
else
if (Rotacast.Data.Expansion ~= 0) then Self:SetAttribute("oldkeybind", RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Binding); else Self:SetAttribute("oldkeybind", RotacastPerDB.SpecData.HotkeyData.Binding); end
Self:SetAttribute("newkeyname", Rotacast.Frames.Binding.Name.HotkeyName)
Self:SetAttribute("newkeybind", Rotacast.Frames.Binding.Name.HotkeyBinding)
end
end)
Rotacast.Frames.Binding.KeySave:HookScript("OnAttributeChanged", function(Self, Name, Value)
if (Name == "newkeybind") then
if (Rotacast.Data.Expansion ~= 0) then
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Name, RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Binding = Self:GetAttribute("newkeyname"), Self:GetAttribute("newkeybind")
if (RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Name) then Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00a"..RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Name); else Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00aNone"); end
else
RotacastPerDB.SpecData.HotkeyData.Name, RotacastPerDB.SpecData.HotkeyData.Binding = Self:GetAttribute("newkeyname"), Self:GetAttribute("newkeybind")
if (RotacastPerDB.SpecData.HotkeyData.Name) then Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00a"..RotacastPerDB.SpecData.HotkeyData.Name); else Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00aNone"); end
end
elseif (Name == "clearbinding") then
if (Rotacast.Frames.Binding.Current:GetText() ~= "Hotkey: |cffffe00aNone") then Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00aNone"); end
elseif (Name == "resetbindingname") then
Rotacast.Frames.Binding.Current:SetText("Hotkey: |cffffe00a"..Value)
end
end)
Rotacast.Frames.Binding.KeySave:SetAttribute("_onattributechanged", [=[
if (name == "newkeybind") then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
local OldKeyBind = self:GetAttribute("oldkeybind")
if (OldKeyBind) then Ref:ClearBinding(OldKeyBind); end
if (value) then Ref:SetBindingClick(false, value, Ref:GetName(), "LeftButton"); end
elseif (name == "clearbinding") then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:ClearBinding(value)
elseif (name == "resetbindingbind") then
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetBindingClick(false, value, Ref:GetName(), "LeftButton")
end
]=])
Rotacast.Frames.Binding.KeySave:HookScript("OnHide", function(Self)
Rotacast.Frames.Binding.Name.HotkeyName, Rotacast.Frames.Binding.Name.HotkeyBinding = nil, nil
Rotacast.Frames.Binding.Name:SetText("")
end)
Rotacast.Frames.CastingOptions.Options2:HookScript("OnClick", function(Self) 
RotacastPerDB.SequenceOptions.AutoCast = Self:GetChecked() 
end)
Rotacast.Frames.CastingOptions.Options2:SetAttribute("_onmouseup", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("autotarget", not Ref:GetAttribute("autotarget"))
]=])
Rotacast.Frames.GeneralOptions.Options1:HookScript("OnClick", function(Self) 
RotacastPerDB.GeneralOptions.Locked = Self:GetChecked() 
end)
Rotacast.Frames.GeneralOptions.Options2:HookScript("OnClick", function(Self) 
RotacastPerDB.GeneralOptions.AutoCastButton = Self:GetChecked() 
end)
Rotacast.Frames.GeneralOptions.Options3:HookScript("OnClick", function(Self) 
RotacastPerDB.GeneralOptions.AutoSequenceBar = Self:GetChecked() 
end)
Rotacast.Frames.Reset.Options2:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Enter = Self:GetChecked() end)
Rotacast.Frames.Reset.Options3:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Leave = Self:GetChecked() end)
Rotacast.Frames.Reset.Options4:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Switch = Self:GetChecked() end)
Rotacast.Frames.CastingOptions.Options1:HookScript("OnClick", function(Self) RotacastPerDB.SequenceOptions.Default = Self:GetChecked() end)
Rotacast.Frames.CastButtonOptions.Options1:HookScript("OnClick", function(Self) RotacastPerDB.CastButtonOptions.Shown = Self:GetChecked() end)
Rotacast.Frames.CastButtonOptions.Options1:SetAttribute("_onmousedown", [=[
local Ref = self:GetFrameRef("CastBackground")
if (Ref:IsVisible()) then Ref:Hide() else Ref:Show(); end
]=])
Rotacast.Frames.CastButtonOptions.Options2:HookScript("OnClick", function(Self)
RotacastPerDB.CastButtonOptions.Cooldowns = Self:GetChecked()
if (Self:GetChecked()) then
Rotacast.Frames.CastButton.cooldown:SetAlpha(1)
else
Rotacast.Frames.CastButton.cooldown:SetAlpha(0)
end
end)
Rotacast.Frames.CastButtonOptions.Sizer:HookScript("OnValueChanged", function(Self, Value)
local value = floor(Value / 1) * 1
if (Self:GetID() ~= value) then
Self:SetID(value)
RotacastPerDB.CastButtonOptions.Scale = value
CooldownFrame_Set(Rotacast.Frames.GenericSizeFrames[value], 1, 1, true)
end
end)
Rotacast.Frames.Guide:SetAttribute("_onclick", [=[
local Ref = self:GetFrameRef("Rotacast.Frames.GuideDisplay")
if (Ref:IsVisible()) then Ref:Hide(); else Ref:Show(); end
]=])
Rotacast.Frames.Restore:SetAttribute("_onclick", [=[
local Parent = self:GetFrameRef("UIParent")
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:ClearAllPoints()
Ref:SetPoint("BOTTOMRIGHT", Parent, "BOTTOMRIGHT", -60, 69)
local Ref = self:GetFrameRef("Rotacast.Frames.Edit.Header")
Ref:ClearAllPoints()
Ref:SetPoint("TOP", Parent, "TOP", 0, 0)
local Ref = self:GetFrameRef("Rotacast.Frames.Options")
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", Parent, "CENTER", -65, 0)
local Ref = self:GetFrameRef("Rotacast.Frames.GuideDisplay")
Ref:ClearAllPoints()
Ref:SetPoint("RIGHT", Parent, "RIGHT", -45, 30)
local Parent, Ref = self:GetFrameRef("MinimapCluster"), self:GetFrameRef("Rotacast.Frames.Icon")
Ref:ClearAllPoints()
Ref:SetPoint("BOTTOMRIGHT", Parent, "BOTTOMRIGHT", 0, 0)
]=])
Rotacast.Frames.Restore:HookScript("OnClick", function()
RotacastPerDB.SetPoints.GuideDisplay[1], RotacastPerDB.SetPoints.GuideDisplay[2], RotacastPerDB.SetPoints.GuideDisplay[3], RotacastPerDB.SetPoints.GuideDisplay[4], RotacastPerDB.SetPoints.GuideDisplay[5] = "RIGHT", "UIParent", "RIGHT", "-45", "30"
RotacastPerDB.SetPoints.Icon[1], RotacastPerDB.SetPoints.Icon[2], RotacastPerDB.SetPoints.Icon[3], RotacastPerDB.SetPoints.Icon[4], RotacastPerDB.SetPoints.Icon[5] = "BOTTOMRIGHT", "Rotacast.Frames.IconContainer", "BOTTOMRIGHT", "0", "0"
RotacastPerDB.SetPoints.CastButton[1], RotacastPerDB.SetPoints.CastButton[2], RotacastPerDB.SetPoints.CastButton[3], RotacastPerDB.SetPoints.CastButton[4], RotacastPerDB.SetPoints.CastButton[5] = "BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", "-60", "69"
RotacastPerDB.SetPoints.Header[1], RotacastPerDB.SetPoints.Header[2], RotacastPerDB.SetPoints.Header[3], RotacastPerDB.SetPoints.Header[4], RotacastPerDB.SetPoints.Header[5] = "TOP", "UIParent", "TOP", "0", "0"
RotacastPerDB.SetPoints.Options[1], RotacastPerDB.SetPoints.Options[2], RotacastPerDB.SetPoints.Options[3], RotacastPerDB.SetPoints.Options[4], RotacastPerDB.SetPoints.Options[5] = "CENTER", "UIParent", "CENTER", "-65", "0"
end)
Rotacast.Frames.Options:HookScript("OnShow", function() RotacastPerDB.LoadShow.Binding = true; PlaySound(839) end)
Rotacast.Frames.Options:HookScript("OnHide", function()
RotacastPerDB.LoadShow.Binding = false
if (Rotacast.Frames.Icon:IsMouseOver()) then GameTooltip:Hide(); Rotacast.Functions.IconMessage(Rotacast.Frames.Icon); end;
PlaySound(840)
end)
Rotacast.Frames.GenericTargetFrame2:HookScript("OnShow", function(Self)
if ((UnitExists("target")) and (UnitCanAttack("player", "target")) and (not UnitIsDead("target"))) then CooldownFrame_Set(Rotacast.Frames.GenericTargetFrame3, 1, 1, true); else CooldownFrame_Set(Rotacast.Frames.GenericTargetFrame4, 1, 1, true); end
end)
Rotacast.Frames.GenericTargetFrame2:SetAttribute("_onshow", [=[self:Hide()]=])
Rotacast.Frames.GenericTargetFrame3:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("validcast", true)
Ref:SetAttribute("*type1", nil)
]=])
Rotacast.Frames.GenericTargetFrame4:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("validcast", false)
Ref:SetAttribute("*type1", "macro")
Ref:SetAttribute("macrotext", "/targetenemy")
]=])
Rotacast.Frames.GenericConditionFrame0:SetAttribute("_onshow", [=[
self:Hide()
local ButtonID = self:GetAttribute("buttonid")
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("deleteid", ButtonID)
Ref:SetAttribute("option", "delete")
]=])
Rotacast.Frames.GenericConditionFrame1:HookScript("OnShow", function(Self)
local ButtonID = Self:GetAttribute("buttonid")
local SingleCast = Rotacast.Frames.Edit.Button[ButtonID]:GetAttribute("singlecast")
Rotacast.Frames.Edit.ButtonAction[ButtonID]:SetShown(SingleCast)
if (Rotacast.Data.Expansion ~= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].SingleCast = SingleCast; else RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].SingleCast = SingleCast; end
end)
Rotacast.Frames.GenericConditionFrame1:SetAttribute("_onshow", [=[
self:Hide()
local ButtonID = self:GetAttribute("buttonid")
local Ref = self:GetFrameRef("Rotacast"..ButtonID)
if (not Ref:GetAttribute("singlecast")) then Ref:SetAttribute("singlecast", true); else Ref:SetAttribute("singlecast", false); end
Ref:SetAttribute("singlecastdone", false)
]=])
Rotacast.Frames.GenericConditionFrame2:HookScript("OnShow", function(Self)
local ButtonID = Self:GetAttribute("buttonid")
local PetFirst = Rotacast.Frames.Edit.Button[ButtonID]:GetAttribute("petfirst")
Rotacast.Frames.Edit.ButtonAction2[ButtonID]:SetShown(PetFirst)
if (Rotacast.Data.Expansion ~= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].PetFirst = PetFirst; else RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].PetFirst = PetFirst; end
end)
Rotacast.Frames.GenericConditionFrame2:SetAttribute("_onshow", [=[
self:Hide()
local ButtonID = self:GetAttribute("buttonid")
local Ref = self:GetFrameRef("Rotacast"..ButtonID)
if (not Ref:GetAttribute("petfirst")) then Ref:SetAttribute("petfirst", true); else Ref:SetAttribute("petfirst", false); end
]=])
Rotacast.Frames.GenericConditionFrame9:HookScript("OnShow", function(Self)
local ButtonID = Self:GetAttribute("buttonid")
local RequiresTarget = Rotacast.Frames.Edit.Button[ButtonID]:GetAttribute("requirestarget")
Rotacast.Frames.Edit.ButtonAction4[ButtonID]:SetShown(RequiresTarget)
if (Rotacast.Data.Expansion ~= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].RequiresTarget = RequiresTarget; else RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].RequiresTarget = RequiresTarget; end
end)
Rotacast.Frames.GenericConditionFrame9:SetAttribute("_onshow", [=[
self:Hide()
local ButtonID = self:GetAttribute("buttonid")
local Ref = self:GetFrameRef("Rotacast"..ButtonID)
if (not Ref:GetAttribute("requirestarget")) then Ref:SetAttribute("requirestarget", true); else Ref:SetAttribute("requirestarget", false); end
]=])
Rotacast.Frames.GenericConditionFrame12:HookScript("OnShow", function(Self)
local ButtonID = Self:GetAttribute("buttonid")
local WaitUncastable = Rotacast.Frames.Edit.Button[ButtonID]:GetAttribute("waituncastable")
Rotacast.Frames.Edit.ButtonAction5[ButtonID]:SetShown(WaitUncastable)
if (Rotacast.Data.Expansion ~= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].WaitUncastable = WaitUncastable; else RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].WaitUncastable = WaitUncastable; end
end)
Rotacast.Frames.GenericConditionFrame12:SetAttribute("_onshow", [=[
self:Hide()
local ButtonID = self:GetAttribute("buttonid")
local Ref = self:GetFrameRef("Rotacast"..ButtonID)
if (not Ref:GetAttribute("waituncastable")) then Ref:SetAttribute("waituncastable", true); else Ref:SetAttribute("waituncastable", false); end
]=])
Rotacast.Frames.GenericConditionFrame3:HookScript("OnShow", function(Self)
if (not UnitAffectingCombat("pet")) then
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame4, 1, 1, true)
else
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame5, 1, 1, true)
end
end)
Rotacast.Frames.GenericConditionFrame3:SetAttribute("_onshow", [=[self:Hide()]=])
Rotacast.Frames.GenericConditionFrame10:HookScript("OnShow", function(Self)
if (UnitExists("target")) then CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame5, 1, 1, true); else CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame4, 1, 1, true); end
end)
Rotacast.Frames.GenericConditionFrame10:SetAttribute("_onshow", [=[self:Hide()]=])
Rotacast.Frames.GenericConditionFrame4:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("validcast", false)
]=])
Rotacast.Frames.GenericConditionFrame5:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("validcast", true)
]=])
Rotacast.Frames.GenericConditionFrame6:HookScript("OnShow", function(Self)
local ButtonID = Self:GetAttribute("buttonid")
local HoldCooldown = Rotacast.Frames.Edit.Button[ButtonID]:GetAttribute("holdcooldown")
Rotacast.Frames.Edit.ButtonAction3[ButtonID].Border:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Red")
Rotacast.Frames.Edit.ButtonAction3[ButtonID]:SetShown(HoldCooldown)
if (Rotacast.Data.Expansion ~= 0) then
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].HoldCooldown = HoldCooldown
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].SkipCooldown = SkipCooldown
else
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].HoldCooldown = HoldCooldown
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].SkipCooldown = SkipCooldown
end
end)
Rotacast.Frames.GenericConditionFrame6:SetAttribute("_onshow", [=[
self:Hide()
local ButtonID = self:GetAttribute("buttonid")
local Ref = self:GetFrameRef("Rotacast"..ButtonID)
if (not Ref:GetAttribute("holdcooldown")) then
Ref:SetAttribute("holdcooldown", true)
Ref:SetAttribute("skipcooldown", false)
else
Ref:SetAttribute("holdcooldown", false)
end
]=])
Rotacast.Frames.GenericConditionFrame7:HookScript("OnShow", function(Self)
local ButtonID = Self:GetAttribute("buttonid")
local SkipCooldown = Rotacast.Frames.Edit.Button[ButtonID]:GetAttribute("skipcooldown")
Rotacast.Frames.Edit.ButtonAction3[ButtonID].Border:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Green")
Rotacast.Frames.Edit.ButtonAction3[ButtonID]:SetShown(SkipCooldown)
if (Rotacast.Data.Expansion ~= 0) then
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].SkipCooldown = SkipCooldown
RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current][ButtonID].HoldCooldown = HoldCooldown
else
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].SkipCooldown = SkipCooldown
RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current][ButtonID].HoldCooldown = HoldCooldown
end
end)
Rotacast.Frames.GenericConditionFrame7:SetAttribute("_onshow", [=[
self:Hide()
local ButtonID = self:GetAttribute("buttonid")
local Ref = self:GetFrameRef("Rotacast"..ButtonID)
if (not Ref:GetAttribute("skipcooldown")) then
Ref:SetAttribute("skipcooldown", true)
Ref:SetAttribute("holdcooldown", false)
else
Ref:SetAttribute("skipcooldown", false)
end
]=])
Rotacast.Frames.GenericConditionFrame8:HookScript("OnShow", function(Self)
local ButtonID = Rotacast.Functions.Cooldown_Skip()
if (ButtonID) then
CooldownFrame_Set(Rotacast.Frames.GenericSkipFrame[ButtonID], 1, 1, true)
end

end)
Rotacast.Frames.GenericConditionFrame8:SetAttribute("_onshow", [=[self:Hide()]=])
Rotacast.Frames.GenericConditionFrame11:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("catcherror", true)			
]=])
Rotacast.Frames.GenericConditionFrame14:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("Rotacast.Frames.CastButton")
Ref:SetAttribute("catcherror", false)			
]=])
WorldMapFrame:HookScript("OnShow", function(Self)
if (Rotacast.Frames.CastButton:IsVisible()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame1, 1, 1, true)
Rotacast.Data.ReOpen[1] = true
else
Rotacast.Data.ReOpen[1] = false
end
if (Rotacast.Frames.Edit.Bar:IsVisible()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame2, 1, 1, true)
Rotacast.Data.ReOpen[2] = true
else
Rotacast.Data.ReOpen[2] = false
end
if (Rotacast.Frames.Options:IsVisible()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame3, 1, 1, true)
Rotacast.Data.ReOpen[3] = true
else
Rotacast.Data.ReOpen[3] = false
end
end)
WorldMapFrame:HookScript("OnHide", function(Self)
if (Rotacast.Data.ReOpen[1]) then CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame1, 1, 1, true); end
if (Rotacast.Data.ReOpen[2]) then CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame2, 1, 1, true); end
if (Rotacast.Data.ReOpen[3]) then CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame3, 1, 1, true); end
end)
end
function Rotacast.Functions.CreateReferences()
Rotacast.Frames.Icon:SetAttribute("Rotacast.Data.Title", Rotacast.Data.Title)
Rotacast.Frames.Icon:SetAttribute("Rotacast.Data.Version", Rotacast.Data.Version)
Rotacast.Frames.CastButton:SetFrameRef("RotacastCooldown", Rotacast.Frames.CastButton.cooldown)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.CastBackground", Rotacast.Frames.CastBackground)
Rotacast.Frames.Icon:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericFrame:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericSlashFrame1:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.Edit.Bar", Rotacast.Frames.Edit.Bar)
Rotacast.Frames.Edit.Bar:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Icon:SetFrameRef("Rotacast.Frames.Edit.Bar", Rotacast.Frames.Edit.Bar)
Rotacast.Frames.Edit.Bar:SetFrameRef("Rotacast.Frames.Icon", Rotacast.Frames.Icon)
Rotacast.Frames.GenericSlashFrame2:SetFrameRef("Rotacast.Frames.Edit.Bar", Rotacast.Frames.Edit.Bar)
Rotacast.Frames.Edit.SequenceDown:SetAttribute("SequenceDown", nil)
Rotacast.Frames.Edit.SequenceUp:SetAttribute("SequenceUp", nil)
Rotacast.Frames.Options:SetFrameRef("Rotacast.Frames.GuideDisplay", Rotacast.Frames.GuideDisplay)
Rotacast.Frames.Icon:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.GenericSlashFrame3:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.GenericEscapeFrame:SetFrameRef("Rotacast.Frames.Options", Rotacast.Frames.Options)
Rotacast.Frames.Binding.ScrollSave:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Binding.ScrollSave:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
Rotacast.Frames.Binding.ScrollSave:SetFrameRef("Rotacast.Frames.Binding.Options1", Rotacast.Frames.Binding.Options1)
Rotacast.Frames.Binding.ScrollSave:SetAttribute("rotacastperdb.scrollbind", RotacastPerDB.ScrollBind)
Rotacast.Frames.Binding.Options1:SetFrameRef("Rotacast.Frames.Binding.ScrollSave", Rotacast.Frames.Binding.ScrollSave)
Rotacast.Frames.Binding.KeySave:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Binding.KeySave:SetFrameRef("Rotacast.Frames.Hotkey", Rotacast.Frames.Options)
if (Rotacast.Data.Expansion ~= 0) then
Rotacast.Frames.Binding.KeySave:SetAttribute("oldkeybind", RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Binding)
Rotacast.Frames.Binding.KeySave:SetAttribute("newkeyname", RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Name)
Rotacast.Frames.Binding.KeySave:SetAttribute("newkeybind", RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].HotkeyData.Binding)
else
Rotacast.Frames.Binding.KeySave:SetAttribute("oldkeybind", RotacastPerDB.SpecData.HotkeyData.Binding)
Rotacast.Frames.Binding.KeySave:SetAttribute("newkeyname", RotacastPerDB.SpecData.HotkeyData.Name)
Rotacast.Frames.Binding.KeySave:SetAttribute("newkeybind", RotacastPerDB.SpecData.HotkeyData.Binding)
end
Rotacast.Frames.CastButton:SetAttribute("autotarget", RotacastPerDB.SequenceOptions.AutoCast)
Rotacast.Frames.CastingOptions.Options2:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.CastButtonOptions.Options1:SetFrameRef("CastBackground", Rotacast.Frames.CastBackground)
Rotacast.Frames.Guide:SetFrameRef("Rotacast.Frames.GuideDisplay", Rotacast.Frames.GuideDisplay)
Rotacast.Frames.Restore:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.Restore:SetFrameRef("Rotacast.Frames.Edit.Header", Rotacast.Frames.Edit.Header)
Rotacast.Frames.Restore:SetFrameRef("Rotacast.Frames.Options", Rotacast.Frames.Options)
Rotacast.Frames.Restore:SetFrameRef("Rotacast.Frames.Icon", Rotacast.Frames.Icon)
Rotacast.Frames.Restore:SetFrameRef("Rotacast.Frames.GuideDisplay", Rotacast.Frames.GuideDisplay)
Rotacast.Frames.Restore:SetFrameRef("UIParent", UIParent)
Rotacast.Frames.Restore:SetFrameRef("MinimapCluster", Rotacast.Frames.IconContainer)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.GenericTargetFrame2", Rotacast.Frames.GenericTargetFrame2)
Rotacast.Frames.GenericTargetFrame3:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericTargetFrame3:SetFrameRef("Rotacast.Frames.GenericConditionFrame3", Rotacast.Frames.GenericConditionFrame3)
Rotacast.Frames.GenericTargetFrame4:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericConditionFrame0:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericConditionFrame4:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericConditionFrame5:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericConditionFrame11:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.GenericConditionFrame14:SetFrameRef("Rotacast.Frames.CastButton", Rotacast.Frames.CastButton)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.GenericConditionFrame3", Rotacast.Frames.GenericConditionFrame3)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.GenericConditionFrame8", Rotacast.Frames.GenericConditionFrame8)
Rotacast.Frames.CastButton:SetFrameRef("Rotacast.Frames.GenericConditionFrame10", Rotacast.Frames.GenericConditionFrame10)
if (RotacastPerDB.LoadShow.Sequence == true) then Rotacast.Frames.Edit.Bar:SetAttribute("loadshow", true); end
end
Rotacast.Data.Expansion = GetAccountExpansionLevel()
SLASH_ROTACAST1, SLASH_ROTACAST2, SLASH_ROTACAST3, SLASH_ROTACAST4 = "/rotacast", "/Rotacast", "/rota", "/Rota"
function SlashCmdList.ROTACAST(msg, editbox)
if (msg == "button") then
if (InCombatLockdown()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame1, 1, 1, true)
else
if (Rotacast.Frames.CastButton:IsShown()) then Rotacast.Frames.CastButton:Hide(); else Rotacast.Frames.CastButton:Show(); end
end
elseif (msg == "sequence") then
if (InCombatLockdown()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame2, 1, 1, true)
else
if (Rotacast.Frames.Edit.Bar:IsShown()) then
Rotacast.Frames.Edit.Bar:Hide()
Rotacast.Frames.Edit.Bar:GetParent():Hide()
else
Rotacast.Frames.Edit.Bar:Show()
Rotacast.Frames.Edit.Bar:GetParent():Show()
end
end
elseif (msg == "options") then
if (InCombatLockdown()) then
CooldownFrame_Set(Rotacast.Frames.GenericSlashFrame3, 1, 1, true)
else
if (Rotacast.Frames.Options:IsShown()) then Rotacast.Frames.Options:Hide(); else Rotacast.Frames.Options:Show(); end
end
elseif (msg == "help") then
print(" ")
print(" ")
print("    "..Rotacast.Data.GuideData1)
print("    "..Rotacast.Data.GuideData2)
print("    "..Rotacast.Data.GuideData3)
print(" ")
print(" ")
else
print(" ")
print(" ")
print("|cffffe00a".."(".."|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version.."|cffffe00a"..")", "|cff69ccf0".."Usage:")
print("|cffffe00a", "/Rotacast,  /rotacast,  /Rota,  /rota")
print("|cffffe00a".."button".."|r", " - Show /Hide Cast Button")
print("|cffffe00a".."sequence".."|r", " - Show /Hide Cast Sequence")
print("|cffffe00a".."options".."|r", " - Show /Hide Options")
print("|cffffe00a".."help".."|r", " - Display Help")
print(" ")
print(" ")
end
end
Rotacast.Frames.Event = CreateFrame("Frame")
Rotacast.Frames.Event:RegisterEvent("ADDON_LOADED")
Rotacast.Frames.Event:RegisterEvent("PLAYER_REGEN_DISABLED")
Rotacast.Frames.Event:RegisterEvent("PLAYER_REGEN_ENABLED")
Rotacast.Frames.Event:RegisterEvent("PLAYER_TARGET_CHANGED")
Rotacast.Frames.Event:RegisterEvent("SPELL_UPDATE_COOLDOWN")
Rotacast.Frames.Event:RegisterEvent("PLAYER_LOGIN")
Rotacast.Frames.Event:RegisterEvent("PLAYER_ENTERING_WORLD")
if (Rotacast.Data.Expansion ~= 0) then
Rotacast.Frames.Event:RegisterEvent("PLAYER_TALENT_UPDATE")
Rotacast.Frames.Event:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
end
Rotacast.Frames.Event:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
Rotacast.Frames.Event:RegisterEvent("UNIT_SPELLCAST_FAILED")
Rotacast.Frames.Event:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
Rotacast.Frames.Event:RegisterEvent("UI_ERROR_MESSAGE")
function Rotacast.Frames.Event:OnEvent(Event, Self, ...)
if (Event == "ADDON_LOADED" and (Self == "Rotacast" or Self == "RotacastClassic")) then
Rotacast.Data.Title, Rotacast.Data.Version = GetAddOnMetadata(Self, "Title"), GetAddOnMetadata(Self, "Version")
print(" ")
print("|cffffe00a".."(".."|cffff7d0a"..Rotacast.Data.Title, "v"..Rotacast.Data.Version, "|cff69ccf0".."Loaded".."|cffffe00a"..")")
print(" ")
end
if (Event == "PLAYER_LOGIN") then
Rotacast.Frames.Event:UnregisterEvent("PLAYER_LOGIN")
Rotacast.Functions.CreateData()
if (Rotacast.Data.Expansion ~= 0) then Rotacast.Functions.SpecData(); end
Rotacast.Functions.UpdateDB()
Rotacast.Functions.CreateFrames()
Rotacast.Functions.CreateEvents()
Rotacast.Functions.CreateReferences()
Rotacast.Functions.Generic("ADDON_ACTION_BLOCKED", {GetFramesRegisteredForEvent("ADDON_ACTION_BLOCKED")})
Rotacast.Functions.Generic("ADDON_ACTION_FORBIDDEN", {GetFramesRegisteredForEvent("ADDON_ACTION_FORBIDDEN")})
Rotacast.Functions.LoadButtons()
end
if (Event == "PLAYER_REGEN_DISABLED") then
if (Rotacast.Frames.Options:IsVisible()) then Rotacast.Frames.Options:Hide(); end
if (RotacastPerDB.GeneralOptions.AutoCastButton and (not Rotacast.Frames.CastButton:IsShown())) then Rotacast.Frames.CastButton:Show(); end
if (RotacastPerDB.GeneralOptions.AutoSequenceBar and (not Rotacast.Frames.Edit.Bar:IsShown())) then
Rotacast.Frames.Edit.Bar:Show()
Rotacast.Frames.Edit.Bar:GetParent():Show()
end
if (Rotacast.Frames.GuideDisplay:IsVisible()) then Rotacast.Frames.GuideDisplay:Hide(); end
if (RotacastPerDB.SequenceOptions.Enter) then
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if (not NextCast) then return; end
for i = 1, Rotacast.Frames.CastButton:GetAttribute("numbuttons") do Rotacast.Frames.Edit.Button[i]:SetAttribute("singlecastdone", false); end
Rotacast.Frames.CastButton:SetAttribute("oldcast", NextCast)
Rotacast.Frames.CastButton:SetAttribute("nextcast", 1)
Rotacast.Frames.CastButton:SetAttribute("castoption", "set")
end
if (RotacastPerDB.SequenceOptions.Default) then
local Current
if (Rotacast.Data.Expansion ~= 0) then Current = RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current; else Current = RotacastPerDB.SpecData.Current; end
if (Current ~= 1) then
if (Rotacast.Data.Expansion ~= 0) then RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current = 1; else RotacastPerDB.SpecData.Current = 1; end
for X = 1, 100 do
Rotacast.Frames.Edit.Button[X]:Hide()
Rotacast.Frames.Edit.Button[X].Border:Hide()
Rotacast.Frames.Edit.ButtonAction[X]:Hide()
Rotacast.Frames.Edit.ButtonAction2[X]:Hide()
Rotacast.Frames.Edit.ButtonAction3[X]:Hide()
Rotacast.Frames.Edit.ButtonAction4[X]:Hide()
Rotacast.Frames.Edit.ButtonAction5[X]:Hide()
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecast", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("singlecastdone", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("petfirst", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("requirestarget", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("skipcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("holdcooldown", false)
Rotacast.Frames.Edit.Button[X]:SetAttribute("waituncastable", false)
end
Rotacast.Frames.CastButton:SetAttribute("nextcast", nil)
if (Rotacast.Frames.CastButton.cooldown:IsVisible()) then CooldownFrame_Set(Rotacast.Frames.CastButton.cooldown, _, _, false); end
Rotacast.Functions.LoadButtons()
end
end
end
if (Event == "PLAYER_REGEN_ENABLED") then
if (RotacastPerDB.SequenceOptions.Leave) then
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if (not NextCast) then return; end
for i = 1, Rotacast.Frames.CastButton:GetAttribute("numbuttons") do Rotacast.Frames.Edit.Button[i]:SetAttribute("singlecastdone", false); end
Rotacast.Frames.CastButton:SetAttribute("oldcast", NextCast)
Rotacast.Frames.CastButton:SetAttribute("nextcast", 1)
Rotacast.Frames.CastButton:SetAttribute("castoption", "set")
end
end
if (Event == "PLAYER_TARGET_CHANGED") then
if (RotacastPerDB.SequenceOptions.Switch) then
if (RotacastPerDB.SequenceOptions.Combat and not InCombatLockdown()) then return; end
local Reset = true
if (not UnitName("target")) then Reset = false; end
if (not (UnitCanAttack("player", "target") or UnitCanAssist("player", "target"))) then Reset = false; end
if (UnitCanAttack("player", "target")) then if (UnitIsDead("target")) then Reset = false; end; end
if (Reset) then CooldownFrame_Set(Rotacast.Frames.GenericFrame, GetTime(), 10, true); end
end
end
if (Event == "SPELL_UPDATE_COOLDOWN") then
if (Rotacast.Data.Expansion ~= 0) then
if (not Rotacast.Data.CurrentSpec) then return; end
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] ~= 0) then Rotacast.Functions.UpdateCooldown(); end
else
if (#RotacastPerDB.SpecData.Buttons[RotacastPerDB.SpecData.Current] ~= 0) then Rotacast.Functions.UpdateCooldown(); end
end
end
if (Rotacast.Data.Expansion ~= 0) then
if (Event == "PLAYER_TALENT_UPDATE") then
if (not Rotacast.Data.CurrentSpec) then return; end
if (Rotacast.Data.CurrentSpec ~= GetSpecializationInfo(GetSpecialization())) then return; end
if (#RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Buttons[RotacastPerDB.SpecData[Rotacast.Data.CurrentSpec].Current] > 0) then Rotacast.Functions.UpdateIconsTalent(); end
if (Rotacast.Frames.CastButton) then Rotacast.Functions.SetSpells(); end
end
if (Event == "PLAYER_SPECIALIZATION_CHANGED") then
Rotacast.Functions.ChangeSpec()
Rotacast.Functions.ChangeKeyBinding()
end
end
if ((Event == "UNIT_SPELLCAST_FAILED") or (Event == "UNIT_SPELLCAST_FAILED_QUIET") or (Event == "UI_ERROR_MESSAGE")) then
if (Rotacast.Frames.CastButton:GetAttribute("catcherror")) then
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame14, 1, 1, true)
local NextCast = Rotacast.Frames.CastButton:GetAttribute("nextcast")
if (not Rotacast.Frames.Edit.Button[NextCast]:GetAttribute("waituncastable")) then
local ButtonID = Rotacast.Functions.Cooldown_Skip()
if (ButtonID) then
CooldownFrame_Set(Rotacast.Frames.GenericSkipFrame[ButtonID], 1, 1, true)
end
end
end
elseif (Event == "UNIT_SPELLCAST_SUCCEEDED") then
if (Rotacast.Frames.CastButton:GetAttribute("catcherror")) then
CooldownFrame_Set(Rotacast.Frames.GenericConditionFrame14, 1, 1, true)
Rotacast.Functions.Set_SingleCastdone()
local ButtonID = Rotacast.Functions.Cooldown_Skip()
if (ButtonID) then
CooldownFrame_Set(Rotacast.Frames.GenericSkipFrame[ButtonID], 1, 1, true)
end
end
end
end
Rotacast.Frames.Event:SetScript("OnEvent", Rotacast.Frames.Event.OnEvent)